
#define SPHERE_FIRE_DOT_DAMAGE		get_pcvar_num( CVAR_wc3_sfire_dotdmg )			// Damage done on each tick 
#define SPHERE_FIRE_DOT				get_pcvar_num( CVAR_wc3_sfire_dot )				// Number of times ticks

Shpere_fire( iCaster, iTarget )
{
	if (!is_user_alive(iTarget) || mass_sfire_fire[iTarget])
	{
		return PLUGIN_HANDLED;
	}
	
	new vTargetOrigin[3];
	get_user_origin( iTarget, vTargetOrigin );
	
	emit_sound( iTarget, CHAN_STATIC, g_szSounds[SOUND_IMMOLATE_BURNING], 0.5, ATTN_NORM, 0, PITCH_NORM );
	
	static flags;
	flags = pev(iTarget, pev_flags);
	
	if (get_pcvar_float(CVAR_sfire_slowdown) > 0.0 && (flags & FL_ONGROUND))
	{
		static Float:velocity[3];
		pev(iTarget, pev_velocity, velocity);
		xs_vec_mul_scalar(velocity, get_pcvar_float(CVAR_sfire_slowdown), velocity);
		set_pev(iTarget, pev_velocity, velocity);
	}

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_SPRITE)
	write_coord(vTargetOrigin[0]+random_num(-5, 5))
	write_coord(vTargetOrigin[1]+random_num(-5, 5))
	write_coord(vTargetOrigin[2]+random_num(-10, 10))
	write_short(g_iSprites[SPR_FIRESH])
	write_byte(random_num(5, 10))
	write_byte(200)
	message_end()

	new parm_DoT[3];
	parm_DoT[0] = iCaster;
	parm_DoT[1] = iTarget;
	parm_DoT[2] = 1;

	// Start the ultimate DoT

	new TaskId = TASK_ITEM_SF_BURNING + iTarget;

	set_task( 0.2, "Sphere_Fire_DoT", TaskId, parm_DoT, 3 );
	
	return PLUGIN_HANDLED;
}

public Sphere_Fire_DoT( parm_DoT[3] )
{
	new iCaster = parm_DoT[0];
    new iTarget = parm_DoT[1];
	new iCounter = parm_DoT[2];
	
	// Stop DoT if the max number of ticks is reached

	if ( iCounter > SPHERE_FIRE_DOT ) 
	{
		Sphere_Fire_Remove( iTarget );
		return PLUGIN_HANDLED;
	}

	new vTargetOrigin[3];
	get_user_origin( iTarget, vTargetOrigin );
	
	emit_sound( iTarget, CHAN_STATIC, g_szSounds[SOUND_IMMOLATE_BURNING], 0.5, ATTN_NORM, 0, PITCH_NORM );
	
	static flags;
	flags = pev(iTarget, pev_flags);
	
	if (get_pcvar_float(CVAR_sfire_slowdown) > 0.0 && (flags & FL_ONGROUND))
	{
		static Float:velocity[3];
		pev(iTarget, pev_velocity, velocity);
		xs_vec_mul_scalar(velocity, get_pcvar_float(CVAR_sfire_slowdown), velocity);
		set_pev(iTarget, pev_velocity, velocity);
	}
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_SPRITE)
	write_coord(vTargetOrigin[0]+random_num(-5, 5))
	write_coord(vTargetOrigin[1]+random_num(-5, 5))
	write_coord(vTargetOrigin[2]+random_num(-10, 10))
	write_short(g_iSprites[SPR_FIRESH])
	write_byte(random_num(5, 10))
	write_byte(200)
	message_end()

	WC3_Damage( iTarget, iCaster, SPHERE_FIRE_DOT_DAMAGE, CSW_IMMOLATE, -1 )

	// If the target is still alive after this, make their screen glow orange and start the task again

    if ( is_user_alive( iTarget ) )
    {
		mass_sfire_fire[iTarget] = true;

		parm_DoT[2]++;

		set_task( 0.2, "Sphere_Fire_DoT", TASK_ITEM_SF_BURNING + iTarget, parm_DoT, 3 );

	}

	return PLUGIN_HANDLED;
}


Sphere_Fire_Remove( iTarget ) 
{
	// Clear global variables and stop the DoT task

	mass_sfire_fire[iTarget] = false;
	
	new vTargetOrigin[3];
	get_user_origin( iTarget, vTargetOrigin );
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, vTargetOrigin)
	write_byte(TE_SMOKE)
	write_coord(vTargetOrigin[0])			// Position
	write_coord(vTargetOrigin[1])
	write_coord(vTargetOrigin[2] - 50)
	write_short(g_smokeSprr )				// Sprite index
	write_byte(random_num(15, 20))					// scale * 10
	write_byte(random_num(10, 20) )			// framerate
	message_end()

	new TaskId = TASK_ITEM_SF_BURNING + iTarget;
    remove_task( TaskId, 0 );

    return PLUGIN_HANDLED;
}