/*
*	Race: Alchemis Functions
*/

//    - (Poison)
AC_SkillsOffensive( iAttacker, iVictim, iHitPlace )
{
	if ( !p_data_b[iVictim][PB_ISCONNECTED] || !p_data_b[iAttacker][PB_ISCONNECTED] || !is_user_alive( iAttacker ) || !is_user_alive(iVictim) )
	{
		return;
	}

	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_POISON );
	if ( iSkillLevel > 0 )
	{

		if ( random_float(MIN_PERCENT_POISON, MAX_PERCENT_POISON ) <= p_poison[iSkillLevel-1] )
		{
			//  
			emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_POISON], 1.0, ATTN_NORM, 0, PITCH_NORM );

			new FunctionSkill[4];
			FunctionSkill[0] = iAttacker;
			FunctionSkill[1] = iVictim;
			FunctionSkill[2] = 1;
			FunctionSkill[3] = iHitPlace;

			new TaskId = TASK_POISON + iVictim;
			set_task( poison_time_Alchemist, "AC_SkillsOffensivePoison", TaskId, FunctionSkill, 3 );
		}
	}
}

public AC_SkillsOffensivePoison( FunctionSkill[4] )
{
    if( !is_user_alive(FunctionSkill[1]))
	return PLUGIN_HANDLED;

	new iAttacker = FunctionSkill[0];
	new iVictim = FunctionSkill[1];
	new iCounter = FunctionSkill[2];
	new iHitPlace = FunctionSkill[3];

	if ( iCounter > poison_number_Alchemist ) 
	{
		AC_SkillsOffensiveRemove( iVictim );
		return PLUGIN_HANDLED;
	}

	if ( is_user_alive( iVictim ) )
	{
		new vVictimOrigin[3];

		//   
		get_user_origin( iVictim, vVictimOrigin );
		
		//  
		Create_TE_SPRITE( vVictimOrigin, g_iSprites[SPR_POISON], 10, 200 );

 		WC3_Damage( iVictim, iAttacker, poison_dmg_Alchemist, CSW_POISON, iHitPlace );

	 	FunctionSkill[2]++;

		set_task( poison_time_Alchemist, "AC_SkillsOffensivePoison", TASK_POISON + iVictim, FunctionSkill, 32 );
	}

	return PLUGIN_HANDLED;
}

AC_SkillsOffensiveRemove( iVictim ) 
{
	new TaskId = TASK_POISON + iVictim;
	remove_task( TaskId, 0 );

	return PLUGIN_HANDLED;
}

//  
AC_SkillsDefensive( iAttacker, iVictim )
{
    if( !is_user_alive( iAttacker ) || !is_user_alive( iVictim ) )
	return;

	static iSkillLevel;

	//    -  (Shock)
	iSkillLevel = SM_GetSkillLevel( iVictim, SKILL_SHOCK );
	if ( iSkillLevel > 0 )
	{
		if ( random_float(MIN_PERCENT_SHOCK, MAX_PERCENT_SHOCK ) <= p_shock[iSkillLevel-1] )
		{
			//   
			Create_ScreenShake( iAttacker, (10<<12), (2<<12), (5<<12) );
		}
	}

	//    -   (Frost)
	iSkillLevel = SM_GetSkillLevel( iVictim, SKILL_FROST );
	if ( iSkillLevel > 0)
	{
		if ( random_float(MIN_PERCENT_FROST, MAX_PERCENT_FROST ) <= p_frost[iSkillLevel-1] && !SHARED_IsPlayerSlowed(iAttacker) )
		{
			//  
			emit_sound( iAttacker, CHAN_STATIC, g_szSounds[SOUND_FROST], 1.0, ATTN_NORM, 0, PITCH_NORM );

			p_data_b[iAttacker][PB_FROST_AL] = true;
			SHARED_SetSpeed( iAttacker );
			
			set_task( frost_hold_time_Alchemist, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + iAttacker );
		}
	}
}

//  -  
public AC_ULT_Eclipse( iCaster, iTarget )
{
    if( !is_user_alive( iCaster ) || !is_user_alive( iTarget ) )
	return PLUGIN_HANDLED;

	new iItemSlot = random_num(0, 1)
	new iItem = g_iShopMenuItems[iTarget][iItemSlot]

	if ( iItem > ITEM_NONE )
	{
		new szItemName[64];

		new vVictimOrigin[3];
		get_user_origin( iTarget, vVictimOrigin );

		vVictimOrigin[2] += 10;

		Create_TE_SPRITE( vVictimOrigin, g_iSprites[SPR_ECLIPSE], 10, 200 );

		//  
		emit_sound( iTarget, CHAN_STATIC, g_szSounds[SOUND_ECLIPSE], 1.0, ATTN_NORM, 0, PITCH_NORM );

		//  
		LANG_GetItemName( iItem, iTarget, szItemName, charsmax(szItemName) );

		if ( random_float(MIN_PERCENT_HYPNOSIS, MAX_PERCENT_HYPNOSIS ) <= p_hypnosis[p_data[iCaster][P_LEVEL]] )
		{
			if ( ITEM_GetSlot( iCaster ) != ITEM_SLOT_FULL )
			{
				if ( ITEM_HasItem( iCaster, iItem ) != iItem)
				{
					//   
					ITEM_GiveItem( iCaster, iItem);
	
					//  
					format(szMessage, sizeof(szMessage) - 1, "^x03%L^x04%L^x03%L ^x01%L",
						LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
						LANG_PLAYER,"CLIENT_PRINT_ECLIPSE",
						szItemName);
	
					cssbChatColor(iCaster, szMessage);
				}
				else
				{
					//       
					new iNewMoney = SHARED_GetUserMoney( iCaster ) + ITEM_Cost( iCaster, iItem );
					SHARED_SetUserMoney( iCaster, iNewMoney );

					new iItemMoney = ITEM_Cost( iCaster, iItem );
	
					//      
					format(szMessage, sizeof(szMessage) - 1, "^x03%L^x04%L^x03%L ^x01%L",
						LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
						LANG_PLAYER,"CLIENT_PRINT_ITEM_IF_THERE",
						szItemName,iItemMoney);
		
					cssbChatColor(iCaster, szMessage);
				}
			}
			//      
			else
			{
				//      
				new iNewMoney = SHARED_GetUserMoney( iCaster ) + ITEM_Cost( iCaster, iItem );
				SHARED_SetUserMoney( iCaster, iNewMoney );

				new iItemMoney = ITEM_Cost( iCaster, iItem );

				//      
				format(szMessage, sizeof(szMessage) - 1, "^x03%L^x04%L^x03%L ^x01%L",
					LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
					LANG_PLAYER,"CLIENT_PRINT_SLOT_FULL",
					szItemName,iItemMoney);
	
				cssbChatColor(iCaster, szMessage);
			}
		}
		else
		{
			format(szMessage, sizeof(szMessage) - 1, "^x03%L^x04%L^x03%L ^x01%L",
				LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
				LANG_PLAYER,"CLIENT_PRINT_ECLIPSE_LOSS",
				szItemName);
	
			cssbChatColor(iCaster, szMessage);
		}

		//     
		ITEM_Remove( iTarget, iItemSlot, false );

	}
	//      
	else
	{
		//  
		format(szMessage, sizeof(szMessage) - 1, "^x03%L^x04%L^x03%L ^x01%L",
			LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			LANG_PLAYER,"CLIENT_PRINT_ITEM_NONE");

		cssbChatColor(iCaster, szMessage);
	}
	return PLUGIN_HANDLED;
}