/*
*	Race: Black Book Functions
*/

//#define BLACKSTRIKE_DAMAGE 20
//#define SHADOW_HOLD_TIME  1.0
// Initial Ultimate call
public BB_ULT_BlackLightning( iCaster, iTarget, iBodyPart )
{

if( !is_user_alive( iCaster ) || !is_user_alive( iTarget ))
return;

//   
new cOrigin[3], tOrigin[3], kOrigin[3], sOrigin[3];
//   
get_user_origin( iCaster, cOrigin, 0 );
get_user_origin(iTarget, tOrigin, 0 );
//   
kOrigin[0] = cOrigin[0];
kOrigin[1] = cOrigin[1];
kOrigin[2] = cOrigin[2] + 50;
sOrigin[0] = tOrigin[0];
sOrigin[1] = tOrigin[1];
sOrigin[2] = tOrigin[2] + 50;
//       
if(is_user_alive(iCaster) && is_user_alive(iTarget))
{
//   
set_user_origin( iTarget, kOrigin );
Create_TE_TELEPORT( kOrigin );
set_user_origin( iCaster, sOrigin );
Create_TE_TELEPORT( sOrigin );
}

return;
}

BB_SkillsOffensive( iAttacker, iVictim, iHitPlace)
{

   if( !is_user_alive( iAttacker ) || !is_user_alive( iVictim ))
   return;

	static iSkillLevel;

	// Black Shadow
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_BLACKSHADOW );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{

		// Cannot bash if already bashed or user is slowed
		if ( random_float( 0.0, 1.0 ) <= p_bshadow[iSkillLevel-1] && !SHARED_IsPlayerSlowed( iVictim ) )
		{		

			p_data_b[iVictim][PB_STUNNED] = true;
			SHARED_SetSpeed( iVictim );
			
			new parm[5];
			
			set_task( shadow_hold_time_BlackMag, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + iVictim );

			// Make the user glow!
			SHARED_Glow( iVictim, 225, 20, 147, 0 );
			
			Create_ScreenShake( iVictim, (10<<12), (3<<12), (6<<12) );	
			 
			Create_ScreenFade( iVictim, 4, (1<<10), (1<<12), 148, 0, 211, 255 );
			 
			set_task( 0.5, "_BB_SuicideBlastCircles", TASK_BEAMCYLINDER + iVictim, parm, 5 );
			
		}
	}

	// Black Strike
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_BLACKSTRIKE );
	if( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
  {
    if ( random_float( 0.0, 1.0 ) <= p_bstrike[iSkillLevel-1] )
	{
	new vTargetOrigin[3], vAttackerOrigin[3], vVictimOrigin[3]; 
	get_user_origin( iVictim, vTargetOrigin );

	Create_TE_EXPLOSION( vTargetOrigin, vTargetOrigin, g_iSprites[SPR_BLACKFIRE], 20, 24, 4 );
	Create_TE_EXPLOSION( vTargetOrigin, vTargetOrigin, g_iSprites[SPR_BURNFIRE], 30, 24, 4 );
	
    get_user_origin( iVictim, vVictimOrigin );
    get_user_origin( iAttacker, vAttackerOrigin );
	
	Create_TE_SPRITETRAIL( vAttackerOrigin, vVictimOrigin, g_iSprites[SPR_BLACKSTRIKE], 50, 15, 2, 2, 6 );

	// Damage the user
	WC3_Damage( iVictim, iAttacker, black_strike_dmg_BlackMag, CSW_BLACKPOWER, iHitPlace );

  }
  
 }
 }
 
BB_SkillsDefensive( iAttacker, iVictim )
{

    if(!is_user_alive( iAttacker ) || !is_user_alive(iVictim))
	return;

	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iVictim, SKILL_BLACKPOWER );
	if ( iSkillLevel > 0 && p_data_b[iVictim][PB_ISFROZENSKILL] == false )
	{

		if ( random_float( 0.0, 1.0 ) <= p_bpower[iSkillLevel-1] )
		{

			// Play the impale sound
			emit_sound( iAttacker, CHAN_STATIC, g_szSounds[SOUND_IMPALE], 1.0, ATTN_NORM, 0, PITCH_NORM );
			
			new Float:vVelocity[3];
			entity_get_vector( iAttacker, EV_VEC_velocity, vVelocity );

			vVelocity[0] = random_float( 100.0, 400.0 );
			vVelocity[1] = random_float( 100.0, 400.0 );
			vVelocity[2] = random_float( 400.0, 700.0 );

			entity_set_vector( iAttacker, EV_VEC_velocity, vVelocity );
	
	    }   
	}
}

// Draw the blast circles
public _BB_SuicideBlastCircles( parm[5] )
{
	new vOrigin[3], vPosition[3];

	vOrigin[0] = parm[2];
	vOrigin[1] = parm[3];
	vOrigin[2] = parm[4] - 16;

	vPosition[0] = vOrigin[0];
	vPosition[1] = vOrigin[1];
	vPosition[2] = vOrigin[2] + 250;

	Create_TE_BEAMCYLINDER( vOrigin, vOrigin, vPosition, g_iSprites[SPR_SHOCKWAVE], 0, 0, 6, 16, 0, 255, 20, 155, 255, 0 );

	vOrigin[2] = ( vOrigin[2] - 250 ) + ( 250 / 2 );

	Create_TE_BEAMCYLINDER( vOrigin, vOrigin, vPosition, g_iSprites[SPR_SHOCKWAVE], 0, 0, 6, 16, 0, 255, 20, 155, 255, 0 );
}

public MM_Blast(idAttacker)
 {
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( idAttacker, ENERGY_DISK );
	if( iSkillLevel > 0 && p_data_b[idAttacker][PB_ISFROZENSKILL] == false && is_user_alive(idAttacker) )
	{
	if (g_friezadisk[idAttacker] > 0 && g_bFriezaDisabled == false) 
	{

	new Float: fOrigin[3], Float:fAngle[3],Float: fVelocity[3];
	
	g_friezadisk[idAttacker] = g_friezadisk[idAttacker] - 1;
	
	pev(idAttacker, pev_origin, fOrigin);
	pev(idAttacker, pev_view_ofs, fAngle);
	fm_velocity_by_aim(idAttacker, 2.0, fVelocity, fAngle);
	fAngle[0] *= -1.0;
	
	// create ent
	new entFArrow = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	set_pev(entFArrow, pev_classname, "FriezaDiskDestroyed");
	engfunc(EngFunc_SetModel, entFArrow, "models/shmod/frieza_friezadisc.mdl");
	set_pev(entFArrow, pev_mins, Float:{-1.0, -1.0, -1.0});
	set_pev(entFArrow, pev_maxs, Float:{1.0, 1.0, 1.0});
	set_pev(entFArrow, pev_origin, fOrigin);
	fOrigin[0] += fVelocity[0];
	fOrigin[1] += fVelocity[1];
	fOrigin[2] += fVelocity[2];

	entity_set_float(entFArrow,EV_FL_framerate,1.0);//framerate
	entity_set_int(entFArrow, EV_INT_rendermode, 4);//randermode
	entity_set_float(entFArrow, EV_FL_renderamt, 255.0);//visable

	set_pev(entFArrow, pev_movetype, MOVETYPE_BOUNCE);
	set_pev(entFArrow, pev_gravity, 0.01);
	fVelocity[0] *= 650;
	fVelocity[1] *= 650;
	fVelocity[2] *= 650;
	set_pev(entFArrow, pev_velocity, fVelocity);
	set_pev(entFArrow, pev_owner, idAttacker);
	set_pev(entFArrow, pev_angles, fAngle);
	set_pev(entFArrow, pev_solid, SOLID_BBOX);//store the enitty id
	
	emit_sound(entFArrow, CHAN_VOICE, "warcraft3/frieza_destructodisc.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
    write_byte(TE_BEAMFOLLOW);       //TE_BEAMFOLLOW
    write_short(entFArrow);  //The entity to attach the sprite to
    write_short(flash);  //sprite's model
    write_byte(10);  //life in 0.1 seconds
    write_byte(50);   //width of sprite
    write_byte(255);  //red
    write_byte(0);    //green
    write_byte(255);  //blue
    write_byte(255);  //brightness
    message_end();

	}
	}
	return PLUGIN_HANDLED;
}

public touchFriezaDistroyed(entFriezaDisk,idWorldPlayer) 
{
	//    -  (,  ..)
	if(idWorldPlayer == 0) 
	{
		if (is_valid_ent(entFriezaDisk)) 
		remove_entity(entFriezaDisk);
	}
	//    
	else if(is_user_connected(idWorldPlayer))
	{
		//          
		new idAttacker = entity_get_edict(entFriezaDisk,EV_ENT_owner);
		if(get_user_team(idWorldPlayer) != get_user_team(idAttacker))
		{
		WC3_Damage(idWorldPlayer, idAttacker, disk_dmg_BlackMag, CSW_SKULL, 0);
		
		if (is_valid_ent(entFriezaDisk)) 
		    remove_entity(entFriezaDisk);
		}
		//         
		else 
		{
			if (is_valid_ent(entFriezaDisk)) 
		    remove_entity(entFriezaDisk);
		}
	} 
	//       
	else
	{
		if (is_valid_ent(entFriezaDisk)) 
		remove_entity(entFriezaDisk);
	}
}