
//new spr_blood_drop, spr_blood_spray

public Dk_Bloood( idUser )
{
	if ( task_exists( idUser + TASK_BLOOD_DK ) == 0 )
	{
		_Dk_Bloood( idUser );
	}
}

// We don't need to ever actually "turn this off" since this task will take care of itself
public _Dk_Bloood( idUser )
{
	if ( idUser >= TASK_BLOOD_DK )
	{
		idUser -= TASK_BLOOD_DK;
	}

	// User is no longer connected
	if ( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( idUser, SKILL_CLAWS_N );

	// User doesn't have this skill, so lets return
	//  - Also return if this was called twice
	if ( iSkillLevel <= 0 || p_data_b[idUser][PB_ISFROZENSKILL] == true)
		return;

	// Continue healing...
	if ( is_user_alive( idUser ) )
	{
		set_task( p_blood_death_knith[iSkillLevel-1], "_Dk_Bloood", TASK_BLOOD_DK + idUser );
	}
	
	// Prevent healing if this player is hexed
	if ( p_data_b[idUser][PB_HEXED] )
	{
		return;
	}

	new players[32], numberofplayers, targetid, targetorigin[3], origin[3];
	new iTeam = get_user_team( idUser );

	get_user_origin( idUser, origin );
	get_players( players, numberofplayers, "a" );
	
	// Loop through each player and check to see if one is close enough to be healed
	for ( new i = 0; i < numberofplayers; i++ )
	{
		targetid = players[i];
		
		// User is on the iAttacker's team
		if ( p_data_b[targetid][PB_ISCONNECTED] && get_user_team( targetid ) != iTeam )
		{
			if ( is_user_alive( targetid ) )
			{
				get_user_origin( targetid, targetorigin );
			
				// User is close enough
				if ( get_distance(origin, targetorigin) < blood_range_DKdf )
				{
					get_user_origin( targetid, origin )
					
					if(get_user_health(targetid) < b_hp_blood_DKdf)
					return;
			
					WC3_Damage( targetid, idUser, dmg_blood_DKdf, CSW_DK_SHOT, 0);
					
					message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
					write_byte(TE_BLOODSTREAM)
					write_coord(origin[0])
					write_coord(origin[1])
					write_coord(origin[2]+10)
					write_coord(random_num(-360,360)) // x
					write_coord(random_num(-360,360)) // y
					write_coord(-10) // z
					write_byte(70) // color
					write_byte(random_num(50,100)) // speed
					message_end()
				}
			}
		}
	}

	return;
}

public UltimateScreenRefresh( idUser )
{

	if ( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	
	new bool:bCanBlockUltimate = false;
 
	new iOrigin[3], iPlayersOrigin[3], players[32], idWorldPlayer, numberofplayers;
	get_user_origin( idUser, iOrigin );
 
	get_players( players, numberofplayers, "a" );
	for ( new i = 0; i < numberofplayers; i++ )
	{
	idWorldPlayer = players[i];
	get_user_origin( idWorldPlayer, iPlayersOrigin );
		if( get_distance( iOrigin, iPlayersOrigin ) < bu_DKdf )
		{
			if( get_user_team( idUser ) != get_user_team( idWorldPlayer ) )
			{
				if( ULT_CanUserBlockUlt( idWorldPlayer ) )
				{
					bCanBlockUltimate = true;
				}
			}
		}
	}
	
	if( bCanBlockUltimate == true )
	{
		ULT_Blocked( idUser );
		ULT_RemoveCharge(idWorldPlayer)
		ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
	}
	
	if(!g_DK_Damage[idUser] && bCanBlockUltimate == false)
	{

	// Set up the user's ultimate delay
	ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
	

	ULT_Icon( idUser, ICON_HIDE );
	
	g_DK_Damage[idUser] = true
	
	new CsArmorType:ArmorType;
	set_user_health(idUser, get_user_health(idUser) + floatround(float(get_user_health(idUser)) * php_DKdf));
	cs_set_user_armor(idUser, get_user_armor(idUser) + floatround(float(get_user_armor(idUser)) * pap_DKdf), ArmorType);
	
	emit_sound(idUser, CHAN_STATIC, g_szSounds[SOUND_HEALTH_POTION], 1.0, ATTN_NORM, 0, PITCH_NORM );

	new vOrigin[3];
	get_user_origin( idUser, vOrigin );

	Create_TE_SPRITE( vOrigin, g_iSprites[SPR_HEALTH_POTION], 15, 200 );

	Create_ScreenFade( idUser, (1<<10), (1<<10), (1<<12), 0, 250, 0, 100 );
	
	set_task( float(ult_dr_DKdf), "DK_Ult_Remove", TASK_ULT_DK + idUser );
	}

	return;
}

public DK_Ult_Remove( idUser )
{
	if ( idUser >= TASK_ULT_DK )
	{
		idUser -= TASK_ULT_DK;
	}

	if ( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	
	if(g_DK_Damage[idUser])
	{
		new CsArmorType:ArmorType;
		set_user_health(idUser, get_user_health(idUser) - floatround(float(get_user_health(idUser)) / (1.0 + php_DKdf) * php_DKdf));	
		cs_set_user_armor(idUser, get_user_armor(idUser) -floatround(float(get_user_armor(idUser)) / (1.0 + pap_DKdf) * pap_DKdf), ArmorType);
		
		g_DK_Damage[idUser] = false
	}

	return;
}

public Dk_DeathCoil( iAttacker, iVictim )//Добавлена в events.inl
{

	if(get_user_team( iVictim ) != get_user_team( iAttacker ) )
	{
		InitDeathCoil_dk( iAttacker, iVictim );
	}

	return PLUGIN_HANDLED;
}
static InitDeathCoil_dk( iAttacker, iVictim )
{
	if (!is_user_alive(iVictim) || !is_user_alive(iAttacker))
	{
	return PLUGIN_HANDLED;
	}
	
	if (is_user_alive(iVictim) || is_user_alive(iAttacker))
	{
	emit_sound(iAttacker, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL_MISSILE], 1.0, ATTN_NORM, 0, PITCH_NORM );

	//Создание модели скелета
	new Float:fOrigin[3];
	entity_get_vector( iAttacker, EV_VEC_origin, fOrigin );

	new skull = WC3_ENTITY_create( "DCOIL_N_ONE", "models/bskull_template1.mdl", fOrigin, MOVETYPE_BOUNCE, SOLID_BBOX, dk_dr_DKdf );

	entity_set_edict( skull, EV_ENT_owner, iAttacker );
	entity_set_edict( skull, EV_ENT_enemy, iVictim );
	
	static rgb[3];
	switch (random_num(1, 2))
	{
	case 1: // red
	{
		rgb[0] = 0 // r
		rgb[1] = 255 // g
		rgb[2] = 255 // b
	}
	case 2: // green
	{
		rgb[0] = 96 // r
		rgb[1] = 224 // g
		rgb[2] = 0 // b
	}
	}

	// Skull effects
	set_entity_rendering( skull, kRenderFxGlowShell, rgb[0], rgb[1], rgb[2], kRenderNormal, 48 );
	Create_TE_BEAMFOLLOW(skull, g_iSprites[SPR_TRAIL], 5, 8, rgb[0], rgb[1], rgb[2], 160 );

	// Seek iVictim
	new arg_write[1];
	arg_write[0] = skull;

	fDeathCoilSeek_dk( arg_write );

	return PLUGIN_HANDLED;
	}
	
	return PLUGIN_HANDLED;
}

public fDeathCoilSeek_dk( arg_read[1] )
{

	new skull = arg_read[0];

	if ( !WC3_is_valid_ent( skull ) )
		return PLUGIN_HANDLED;

	new iVictim = entity_get_edict( skull, EV_ENT_enemy );

	if ( !is_user_alive( iVictim ) )
		return PLUGIN_HANDLED;

	// Project skull towards iVictim
	set_velocity_to_ent( skull, iVictim, dk_vel_DKdf );

	// Repeat until iVictim is hit
	new task = TASK_TEMPENTITY + skull;
	set_task( 0.1, "fDeathCoilSeek_dk", task, arg_read, 1 );

	return PLUGIN_HANDLED;
}

static fDeathCoilDamage_dk( iAttacker, iVictim) 
{

	// Play sound
	emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL], 1.0, ATTN_NORM, 0, PITCH_NORM );

	// Generate effects
	fDeathCoilEffects_dk( iVictim );

	// Unset velocity
	new Float:fVelocity[3];
	new CsArmorType:ArmorType;
	
	entity_get_vector( iVictim, EV_VEC_velocity, fVelocity );

	fVelocity[0] = 0.0;
	fVelocity[1] = 0.0;

	if (get_user_armor(iAttacker) < 100)
	{
	if ( get_user_armor( iAttacker ) + ap_vor_DKdf > 100 )
	{
	cs_set_user_armor(iAttacker, 100, ArmorType);
	}
	else
	{
	cs_set_user_armor(iAttacker, get_user_armor(iAttacker) + ap_vor_DKdf, ArmorType);
	}
	}
	
	if (get_user_health(iAttacker) < get_user_maxhealth(iAttacker))
	{
	if ( get_user_health( iAttacker ) + hp_vor_DKdf > get_user_maxhealth( iAttacker ) )
	{
	set_user_health( iAttacker, get_user_maxhealth( iAttacker ) );
	}
	else
	{
	set_user_health(iAttacker, get_user_health(iAttacker) + hp_vor_DKdf);
	}
	}

	return PLUGIN_HANDLED;
}

static fDeathCoilRemove_dk( skull ) 
{
	new task = TASK_TEMPENTITY + skull;
	remove_task( task, 0 );

	if (is_valid_ent(skull)) 
		remove_entity( skull );

	return PLUGIN_HANDLED;
}


public touchSkullExp_dk( entSkull, idWorldPlayer ) 
{

	// Sanity checks
	if ( idWorldPlayer < 1 || idWorldPlayer > 32 || entSkull < 1 || !is_user_alive( idWorldPlayer ) )
	{
	//	fCreateExplodeIceArrow(entSkull);
	//	fDeathCoilRemove_dk( entSkull );
	//	return PLUGIN_CONTINUE;
	}

	//Если попадает в какое-нибудь место (стена,пол и т.д.)
	if(idWorldPlayer == 0) 
	{
		fCreateExplodeIceArrow(entSkull);
		fDeathCoilRemove_dk( entSkull );
		
		return PLUGIN_CONTINUE;
	}
	//Если попадает в игрока
	else if(is_user_connected(idWorldPlayer))
	{
		new iAttacker = entity_get_edict( entSkull, EV_ENT_owner );
		new iVictim = entity_get_edict( entSkull, EV_ENT_enemy );
		//Если попадает в игрока и он не из твоей команды
		if(get_user_team(idWorldPlayer) != get_user_team(iAttacker))
		{
			fDeathCoilDamage_dk( iAttacker, iVictim );
			fDeathCoilRemove_dk( entSkull );
		}
		//Если попадает в игрока и он из твоей команды
		else 
		{
			//fCreateExplodeIceArrow(entIceArrow)
			//fDeathCoilRemove_dk( entSkull );
			//fCreateExplodeIceArrow(entSkull);
		}
	} 
	//Если игрок запустил стрелу и вышел с сервера
	else
	{
		//fCreateExplodeIceArrow(entIceArrow);
		fCreateExplodeIceArrow(entSkull);
		fDeathCoilRemove_dk( entSkull );
		
	}

	return PLUGIN_CONTINUE;
}

public Dk_DeathCoil2( iAttacker, iVictim )//Добавлена в events.inl
{

	if(get_user_team( iAttacker ) != get_user_team( iVictim ) )
	{
		InitDeathCoil_dk2( iAttacker, iVictim );
	}

	return PLUGIN_HANDLED;
}
static InitDeathCoil_dk2( iAttacker, iVictim )
{
	if (!is_user_alive(iVictim) || !is_user_alive(iAttacker))
	{
	return PLUGIN_HANDLED;
	}
	
	if (is_user_alive(iVictim) || is_user_alive(iAttacker))
	{
	emit_sound(iVictim, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL_MISSILE], 1.0, ATTN_NORM, 0, PITCH_NORM );

	//Создание модели скелета
	new Float:fOrigin[3];
	entity_get_vector( iVictim, EV_VEC_origin, fOrigin );

	new skulls = WC3_ENTITY_create( "DCOIL_N_TWO", "models/bskull_template1.mdl", fOrigin, MOVETYPE_BOUNCE, SOLID_BBOX, dk_dr_DKdf );
	
	entity_set_edict( skulls, EV_ENT_owner, iVictim );
	entity_set_edict( skulls, EV_ENT_enemy, iAttacker);

	static rgb[3];
	switch (random_num(1, 2))
	{
	case 1: // red
	{
		rgb[0] = 0 // r
		rgb[1] = 255 // g
		rgb[2] = 255 // b
	}
	case 2: // green
	{
		rgb[0] = 96 // r
		rgb[1] = 224 // g
		rgb[2] = 0 // b
	}
	}

	// Skull effects
	set_entity_rendering( skulls, kRenderFxGlowShell, rgb[0], rgb[1], rgb[2], kRenderNormal, 48 );
	Create_TE_BEAMFOLLOW(skulls, g_iSprites[SPR_TRAIL], 5, 8, rgb[0], rgb[1], rgb[2], 160 );

	// Seek iVictim
	new arg_write[1];
	arg_write[0] = skulls;

	fDeathCoilSeeksb_dk2( arg_write );
	
	return PLUGIN_HANDLED;
	}
	return PLUGIN_HANDLED;
}


public fDeathCoilSeeksb_dk2( arg_read[1] )
{

	new skull = arg_read[0];

	if ( !WC3_is_valid_ent( skull ) )
		return PLUGIN_HANDLED;

	new iVictim = entity_get_edict( skull, EV_ENT_enemy );

	if ( !is_user_alive( iVictim ) )
		return PLUGIN_HANDLED;

	// Project skull towards iVictim
	set_velocity_to_ent( skull, iVictim, dk_vel_DKdf );

	// Repeat until iVictim is hit
	new task = TASK_TEMPENTITY + skull;
	set_task( 0.1, "fDeathCoilSeeksb_dk2", task, arg_read, 1 );

	return PLUGIN_HANDLED;
}


static fDeathCoilDamage_dk2( iAttacker, iVictim) 
{
	if(is_user_alive(iAttacker))
	{
		new Float:fVelocity[3];
		new CsArmorType:ArmorType;
		if(is_user_alive(iVictim))
		{
			// Play sound
			emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL], 1.0, ATTN_NORM, 0, PITCH_NORM );

			// Generate effects
			fDeathCoilEffects_dk( iVictim);

			// Unset velocity
			
			entity_get_vector( iVictim, EV_VEC_velocity, fVelocity );
		}	

		fVelocity[0] = 0.0;
		fVelocity[1] = 0.0;
		
		if (get_user_armor(iAttacker) < 100)
		{
		if ( get_user_armor( iAttacker ) + ap_vor_DKdf > 100 )
		{
		cs_set_user_armor(iAttacker, 100, ArmorType);
		}
		else
		{
		cs_set_user_armor(iAttacker, get_user_armor(iAttacker) + ap_vor_DKdf, ArmorType);
		}
		}
		
		if (get_user_health(iAttacker) < get_user_maxhealth(iAttacker))
		{
		if ( get_user_health( iAttacker ) + hp_vor_DKdf > get_user_maxhealth( iAttacker ) )
		{
		set_user_health( iAttacker, get_user_maxhealth( iAttacker ) );
		}
		else
		{
		set_user_health(iAttacker, get_user_health(iAttacker) + hp_vor_DKdf);
		}
	}
	}

	return PLUGIN_HANDLED;
}

static fDeathCoilEffects_dk( iAttacker )
{
	Create_ScreenFade( iAttacker, (1<<10), (1<<10), FADE_OUT, DEATHCOIL_TRAIL_RGB[GLOW_R], DEATHCOIL_TRAIL_RGB[GLOW_G], DEATHCOIL_TRAIL_RGB[GLOW_B], 160 );

	new Origin[3];
	get_user_origin( iAttacker, Origin );

	Create_TE_EXPLOSION( Origin, Origin, g_iSprites[SPR_DEATHCOIL], 20, 24, 4 );

	Create_TE_ELIGHT(iAttacker, Origin, 100, DEATHCOIL_TRAIL_RGB[GLOW_R], DEATHCOIL_TRAIL_RGB[GLOW_G],DEATHCOIL_TRAIL_RGB[GLOW_B], 10, 0 );

	return PLUGIN_HANDLED;
}

public touchDeathCoil_dk2( entSkull, idWorldPlayer ) 
{

	// Sanity checks
	if ( idWorldPlayer < 1 || idWorldPlayer > 32 || entSkull < 1 || !is_user_alive( idWorldPlayer ) )
	{
	//	fCreateExplodeIceArrow(entSkull);
	//	fDeathCoilRemove_dk( entSkull );
	//	return PLUGIN_CONTINUE;
	}

	//Если попадает в какое-нибудь место (стена,пол и т.д.)
	if(idWorldPlayer == 0) 
	{
		fCreateExplodeIceArrow(entSkull);
		fDeathCoilRemove_dk( entSkull );
		
		return PLUGIN_CONTINUE;
	}
	//Если попадает в игрока
	else if(is_user_connected(idWorldPlayer))
	{
		new iAttacker = entity_get_edict( entSkull, EV_ENT_owner );
		new iVictim = entity_get_edict( entSkull, EV_ENT_enemy );
		//Если попадает в игрока и он не из твоей команды
		if(get_user_team(idWorldPlayer) != get_user_team(iAttacker))
		{
			if(pev_valid(iAttacker))if(pev_valid(iVictim))fDeathCoilDamage_dk2( iAttacker, iVictim );
			if(pev_valid(entSkull))fDeathCoilRemove_dk( entSkull );
		}
		//Если попадает в игрока и он из твоей команды
		else 
		{
			//fCreateExplodeIceArrow(entIceArrow)
			//fDeathCoilRemove_dk( entSkull );
			//fCreateExplodeIceArrow(entSkull);
		}
	} 
	//Если игрок запустил стрелу и вышел с сервера
	else
	{
		//fCreateExplodeIceArrow(entIceArrow);
		fCreateExplodeIceArrow(entSkull);
		fDeathCoilRemove_dk( entSkull );
		
	}

	return PLUGIN_CONTINUE;
}