/*
*	Race: Frost Mage Functions
*/
new FIREJUMP_RADIUS = 150;
new FIREMENTS_DAMAGE = 20;
new FIR_DAMAGE = 20;
new FIREMAGE_DAMAGE = 61;
new DAMAGE_FR_RAD = 250;
new Float:FIRE_MAGE_SLOWDOWN = 2.0;
new Float:FIRE_MAGE_SLOWDOWN_JP = 0.5;
new FIRE_MAGE_JP_COOLDOWN = 30;
new FIRE_MAGE_JP_DOT = 5;
new FIRE_MAGE_JP_DMG = 2;
new FBDMG = 40;
new FBDMG1 = 150;

new g_timer_on_jg[33];

new Float:g_fAngles[33][3];
new bool:g_inFire[33];

FR_SkillsOffensive( iAttacker, iVictim )
{

	static iSkillLevel;
	
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_FIRETBOLT )
	if( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false && get_user_team( iAttacker ) != get_user_team( iVictim ))
	{
	    if ( random_float( 0.0, 1.0 ) <= p_firebolt[iSkillLevel-1] )
		{	
	    fCreateFireArrowTrail(iAttacker);
	    }
 
    }
	
	// Frost Cone
	iSkillLevel = SM_GetSkillLevel( iVictim, SKILL_CONEFIRE );

	if ( iSkillLevel > 0 && p_data_b[iVictim][PB_ISFROZENSKILL] == false )
	{
		if ( random_float( 0.0, 1.0 ) <= p_conefire[iSkillLevel-1] )
		{
						
			p_data_b[iAttacker][PB_STUNNED] = true;
			SHARED_SetSpeed( iAttacker );
			
			set_task( FIRE_MAGE_SLOWDOWN, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + iAttacker );

			// Make the user glow!
			SHARED_Glow( iAttacker, 255, 0, 0, 255 );
			
			WC3_Damage( iAttacker, iVictim, 4, CSW_FIREMENTS, 0 );
			
			Create_ScreenShake( iAttacker, (10<<12), (3<<12), (6<<12) );
						
			// Create a screen fade
			Create_ScreenFade( iAttacker, (1<<10), (2<<10), (1<<12), 255, 0, 0, 100 )
		
		}
	}
		
}

public RR_Skill_Attack( iAttacker, iVictim, iHitPlace )
{
	static iSkillLevel;

	// Fragments Frost
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_FIREMENTS );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false && get_user_team( iAttacker ) != get_user_team( iVictim ) )
	{

	if ( random_float( 0.0, 1.0 ) <= p_firements[iSkillLevel-1] )
	{
	
	emit_sound(iAttacker, CHAN_STATIC, g_szSounds[SOUND_BLIZZARD], 0.5, ATTN_NORM, 0, PITCH_NORM );

	new vOrigin[3];
	get_user_origin( iVictim, vOrigin );

	new ptStartBlizzard[3], ptEndBlizzard[3];
	ptStartBlizzard[0] = vOrigin[0];
	ptStartBlizzard[1] = vOrigin[1];
	ptStartBlizzard[2] = vOrigin[2] + 600;
	ptEndBlizzard[0] = vOrigin[0];
	ptEndBlizzard[1] = vOrigin[1];
	ptEndBlizzard[2] = vOrigin[2] - 600;

	WC3_Damage( iVictim, iAttacker, FIREMENTS_DAMAGE, CSW_FIREMENTS, iHitPlace );

	Create_TE_SPRITETRAIL(ptStartBlizzard, ptEndBlizzard, g_iSprites[SPR_FIREMENTS],50, random_num(27,30), 1, random_num(30,70), 40 );
	Create_TE_SPRITE( vOrigin, g_iSprites[SPR_FIREBOT], 30, 200 );
	Create_TE_SPRITE( vOrigin, g_iSprites[SPR_FIREMENTS], 7, 200 );
	}
	}
	
	return PLUGIN_HANDLED;
}

public FR_ULT_BlueStorm( iCaster, iTarget, iBodyPart )
{
//	client_print(0,print_chat,"FM_ULT_Blizzard");

	emit_sound(iCaster, CHAN_STATIC, g_szSounds[SOUND_BLIZZARD], 0.5, ATTN_NORM, 0, PITCH_NORM );

	new vOrigin[3];
	get_user_origin( iTarget, vOrigin );

	new ptStartBlizzard[3], ptEndBlizzard[3];
	ptStartBlizzard[0] = vOrigin[0];
	ptStartBlizzard[1] = vOrigin[1];
	ptStartBlizzard[2] = vOrigin[2] + 600;
	ptEndBlizzard[0] = vOrigin[0];
	ptEndBlizzard[1] = vOrigin[1];
	ptEndBlizzard[2] = vOrigin[2] - 600;

	WC3_Damage(iTarget, iCaster, FIREMAGE_DAMAGE, CSW_BLIZZARD, iBodyPart );

	Create_TE_BEAMPOINTS( ptStartBlizzard, ptEndBlizzard, g_iSprites[SPR_NEWFIREMAGE], 5, 9, 9, 500, 25, 255, 0, 0, 255, 10 );
	Create_TE_SPRITETRAIL(ptStartBlizzard, ptEndBlizzard, g_iSprites[SPR_FIREMAGEBELLS],100, random_num(50,100), 2, random_num(10,30), 40 )

	new team = get_user_team( iTarget );
	new arrPlayers[32], iNumPlayers, vClosestTargetOrigin[3];
	get_players(arrPlayers, iNumPlayers, "a");

	//    
	for(new i = 0; i < iNumPlayers; i++ )
	{
		if ( is_user_alive( arrPlayers[i] ) )
		{
			if (arrPlayers[i] != iTarget)
			{
				if ( get_user_team( arrPlayers[i] ) == team )
				{
					get_user_origin( arrPlayers[i], vClosestTargetOrigin );

					if ( get_distance( vOrigin, vClosestTargetOrigin ) <= DAMAGE_FR_RAD )
					{
						WC3_Damage( arrPlayers[i],iCaster, FIR_DAMAGE, CSW_BLIZZARD, 0 );
											
						emit_sound(iTarget, CHAN_STATIC, g_szSounds[SOUND_BLIZZARD], 0.5, ATTN_NORM, 0, PITCH_NORM );
					}
				}
			}
		}
	}
	
	return PLUGIN_HANDLED;
}

public fCreateFireArrowTrail(idAttacker)
 {
	if (!is_user_alive(idAttacker)) 
		return PLUGIN_HANDLED;

	new Float: fOrigin[3], Float:fAngle[3],Float: fVelocity[3];
	pev(idAttacker, pev_origin, fOrigin);
	pev(idAttacker, pev_view_ofs, fAngle);
	fm_velocity_by_aim(idAttacker, 2.0, fVelocity, fAngle);
	fAngle[0] *= -1.0;
	
	// create ent
	new entFireArrow = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	set_pev(entFireArrow, pev_classname, "fire_arrow");
	engfunc(EngFunc_SetModel, entFireArrow, "sprites/warcraft3/fire_arrow.spr");
	set_pev(entFireArrow, pev_mins, Float:{-1.0, -1.0, -1.0});
	set_pev(entFireArrow, pev_maxs, Float:{1.0, 1.0, 1.0});
	set_pev(entFireArrow, pev_origin, fOrigin);
	fOrigin[0] += fVelocity[0];
	fOrigin[1] += fVelocity[1];
	fOrigin[2] += fVelocity[2];

	entity_set_float(entFireArrow,EV_FL_framerate,1.0);//framerate
	entity_set_int(entFireArrow, EV_INT_rendermode, 5);//randermode
	entity_set_float(entFireArrow, EV_FL_renderamt, 255.0);//visable

	set_pev(entFireArrow, pev_movetype, MOVETYPE_BOUNCE);
	set_pev(entFireArrow, pev_gravity, 0.01);
	fVelocity[0] *= 800;
	fVelocity[1] *= 800;
	fVelocity[2] *= 800;
	set_pev(entFireArrow, pev_velocity, fVelocity);
	set_pev(entFireArrow, pev_owner, idAttacker);
	set_pev(entFireArrow, pev_angles, fAngle);
	set_pev(entFireArrow, pev_solid, SOLID_BBOX);//store the enitty id
	
	Create_TE_BEAMFOLLOW( entFireArrow, g_iSprites[SPR_TRAIL], 10, 30, 255, 0, 0, 255 );
	
	return PLUGIN_HANDLED;

}

public fCreateExplodeFireArrow(entFireArrow)
{
	new Float:fOrigin[3];
	new iOrigin[3];
	entity_get_vector(entFireArrow, EV_VEC_origin, fOrigin);
	FVecIVec(fOrigin, iOrigin);

	Create_TE_EXPLOSION( iOrigin, iOrigin, g_iSprites[SPR_FIREBOOM], 40, 24, 0 );
	
	new idAttacker = entity_get_edict(entFireArrow, EV_ENT_owner);
	new team = get_user_team( idAttacker );
	new arrPlayers[32], iNumPlayers, vClosestTargetOrigin[3];
	get_players(arrPlayers, iNumPlayers, "a");

	//    
	for(new i = 0; i < iNumPlayers; i++ )
	{
		if ( is_user_alive( arrPlayers[i] ) )
		{
			if (arrPlayers[i] != idAttacker)
			{
				if ( get_user_team( arrPlayers[i] ) != team )
				{
					get_user_origin( arrPlayers[i], vClosestTargetOrigin );

					if ( get_distance( iOrigin, vClosestTargetOrigin ) <= FBDMG1 )
					{
						WC3_Damage( arrPlayers[i], idAttacker, FBDMG, CSW_SKULL, 0 );
						
						Create_ScreenShake( arrPlayers[i], (1<<14), (1<<13), (1<<14) );
			
						// Make the user glow!
						SHARED_GlowShell(arrPlayers[i], 255, 0, 0, 2.5, 30);
					}
				}
			}
		}
	}

	if (is_valid_ent(entFireArrow)) 
		remove_entity(entFireArrow);
}

public touch_fire_arrow(entFireArrow, idWorldPlayer) 
{
	//    -  (,  ..)
	if(idWorldPlayer == 0) 
	{
		fCreateExplodeFireArrow(entFireArrow);
	}
	//    
	else if(is_user_connected(idWorldPlayer) && p_data_b[idWorldPlayer][PB_ISFROZENPLAYER] == false)
	{
		//          
		new idAttacker = entity_get_edict(entFireArrow,EV_ENT_owner);
		if(get_user_team(idWorldPlayer) != get_user_team(idAttacker))
		{
			fCreateExplodeFireArrow(entFireArrow);
		}
		//         
		else 
		{
			if (is_valid_ent(entFireArrow)) 
			remove_entity(entFireArrow);
		}
	} 
	//       
	else
	{
		fCreateExplodeFireArrow(entFireArrow);
	}
}

public fire_jump(id)
{
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( id, FIRE_JUMP );
	if( iSkillLevel > 0 && p_data_b[id][PB_ISFROZENSKILL] == false && is_user_alive(id) )
	{
	
	if(!mass_off_jpf[id])
	{
	g_inFire[id] = true;
	mass_off_jpf[id] = true;
	set_task(0.4, "off_fire", TASK_FIRE_JIMP_O + id);
	
	g_timer_on_jg[id] = FIRE_MAGE_JP_COOLDOWN;
	
	if(mass_off_jpf[id])
	{
		set_task(1.0, "on_fire_jp", TASK_FIRE_JIMP_TH + id);
	}
	
	pev(id, pev_v_angle, g_fAngles[id]);
	angle_vector(g_fAngles[id], ANGLEVECTOR_FORWARD, g_fAngles[id]);
	xs_vec_mul_scalar(g_fAngles[id], 2000.0, g_fAngles[id]);
	g_fAngles[id][2] = 10.0;
	
	emit_sound(id, CHAN_STATIC, g_szSounds[SOUND_FIRE_JUMP], 1.0, ATTN_NORM, 0, PITCH_NORM );
	}
	}
	
	return PLUGIN_CONTINUE
}

public on_fire_jp(id)
{
	if ( id >= TASK_FIRE_JIMP_TH )
	{
		id -= TASK_FIRE_JIMP_TH;
	}
	
	if(g_timer_on_jg[id] <= 1)
	{
		mass_off_jpf[id] = false;
		WC3_StatusText( id, TXT_TIMER, "%L", LANG_PLAYER, "FIRE_JUMP_READY" )
		return;
	}
	
	g_timer_on_jg[id]--
	
	if(g_timer_on_jg[id] > 0 && mass_off_jpf[id])
	{
		set_task(1.0, "on_fire_jp", TASK_FIRE_JIMP_TH + id);
		
		format(szMessage, sizeof(szMessage) - 1, "%d %L",g_timer_on_jg[id], LANG_PLAYER,"FIRE_JUMP_COOLDOWN");
		WC3_StatusText( id, TXT_TIMER, szMessage);
	}
	
	return;
}

public off_fire(id)
{
	if ( id >= TASK_FIRE_JIMP_O )
	{
		id -= TASK_FIRE_JIMP_O;
	}
	
	g_inFire[id] = false
	
	if(!is_user_alive(id))
		return
	
	xs_vec_div_scalar(g_fAngles[id], 2000.0, g_fAngles[id])
	g_fAngles[id][2] = 10.0
	
	set_pev(id, pev_velocity, g_fAngles[id])
}

public PreThink_fj(id)
{
	if(!is_user_alive(id))
		return;
	
	if(!g_inFire[id])
		return;
		
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( id, FIRE_JUMP );
	if( iSkillLevel > 0 && p_data_b[id][PB_ISFROZENSKILL] == false && is_user_alive(id) )
	{
	
	new fOrigin[3], vAxisOrigin[3], vInitOrigin[3];
	get_user_origin(id, fOrigin);
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_SPRITE)
	write_coord(fOrigin[0]+random_num(-5, 5))
	write_coord(fOrigin[1]+random_num(-5, 5))
	write_coord(fOrigin[2]+random_num(-10, 10))
	write_short(g_iSprites[SPR_FIRESH])
	write_byte(random_num(5, 10))
	write_byte(200)
	message_end()
	
	vInitOrigin[0] = fOrigin[0];
	vInitOrigin[1] = fOrigin[1];
	vInitOrigin[2] = fOrigin[2] - 16;
	
	vAxisOrigin[2] += fOrigin[2] + FIREJUMP_RADIUS;
	Create_TE_BEAMCYLINDER(fOrigin, vInitOrigin, vAxisOrigin, g_iSprites[SPR_FJM], 0, 0, 10, 30, 0, 255, 0, 0, 255, 0);
	
	new team = get_user_team( id );
	new arrPlayers[32], iNumPlayers, vClosestTargetOrigin[3];
	get_players(arrPlayers, iNumPlayers, "a");
	
	for(new i = 0; i < iNumPlayers; i++ )
	{
		if ( is_user_alive( arrPlayers[i] ) )
		{
			if (arrPlayers[i] != id)
			{
				if ( get_user_team( arrPlayers[i] ) != team )
				{
					get_user_origin( arrPlayers[i], vClosestTargetOrigin );

					if ( get_distance( fOrigin, vClosestTargetOrigin ) <= FIREJUMP_RADIUS )
					{
						jp_fire(id, arrPlayers[i]);
					}
				}
			}
		}
	}
	
	set_pev(id, pev_velocity, g_fAngles[id])
	}
}

jp_fire( iCaster, iTarget )
{
	if (!is_user_alive(iTarget) || mass_fjump[iTarget])
	{
		return PLUGIN_HANDLED;
	}
	
	new vTargetOrigin[3];
	get_user_origin( iTarget, vTargetOrigin );
	
	static flags;
	flags = pev(iTarget, pev_flags);
	
	if (FIRE_MAGE_SLOWDOWN_JP > 0.0 && (flags & FL_ONGROUND))
	{
		static Float:velocity[3];
		pev(iTarget, pev_velocity, velocity);
		xs_vec_mul_scalar(velocity, get_pcvar_float(CVAR_sfire_slowdown), velocity);
		set_pev(iTarget, pev_velocity, velocity);
	}
	
	WC3_Damage( iTarget, iCaster, FIRE_MAGE_JP_DMG, CSW_IMMOLATE, -1 );
	
	mass_fjump[iTarget] = true;

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_SPRITE)
	write_coord(vTargetOrigin[0]+random_num(-5, 5))
	write_coord(vTargetOrigin[1]+random_num(-5, 5))
	write_coord(vTargetOrigin[2]+random_num(-10, 10))
	write_short(g_iSprites[SPR_FIRESH])
	write_byte(random_num(5, 10))
	write_byte(200)
	message_end()

	new parm_DoT[3];
	parm_DoT[0] = iCaster;
	parm_DoT[1] = iTarget;
	parm_DoT[2] = 1;

	// Start the ultimate DoT

	new TaskId = TASK_FIRE_JIMP_T + iTarget;

	set_task( 0.2, "Jp_Fire_DoT", TaskId, parm_DoT, 3 );
	
	return PLUGIN_HANDLED;
}

public Jp_Fire_DoT( parm_DoT[3] )
{
	new iCaster = parm_DoT[0];
    new iTarget = parm_DoT[1];
	new iCounter = parm_DoT[2];
	
	// Stop DoT if the max number of ticks is reached

	if ( iCounter > FIRE_MAGE_JP_DOT ) 
	{
		Jp_Fire_Remove( iTarget );
		return PLUGIN_HANDLED;
	}

	new vTargetOrigin[3];
	get_user_origin( iTarget, vTargetOrigin );
	
	static flags;
	flags = pev(iTarget, pev_flags);
	
	if (FIRE_MAGE_SLOWDOWN_JP > 0.0 && (flags & FL_ONGROUND))
	{
		static Float:velocity[3];
		pev(iTarget, pev_velocity, velocity);
		xs_vec_mul_scalar(velocity, get_pcvar_float(CVAR_sfire_slowdown), velocity);
		set_pev(iTarget, pev_velocity, velocity);
	}
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_SPRITE)
	write_coord(vTargetOrigin[0]+random_num(-5, 5))
	write_coord(vTargetOrigin[1]+random_num(-5, 5))
	write_coord(vTargetOrigin[2]+random_num(-10, 10))
	write_short(g_iSprites[SPR_FIRESH])
	write_byte(random_num(5, 10))
	write_byte(200)
	message_end()

	WC3_Damage( iTarget, iCaster, FIRE_MAGE_JP_DMG, CSW_IMMOLATE, -1 );

	// If the target is still alive after this, make their screen glow orange and start the task again

    if ( is_user_alive( iTarget ) )
    {
		mass_fjump[iTarget] = true;

		parm_DoT[2]++;

		set_task( 0.2, "Jp_Fire_DoT", TASK_FIRE_JIMP_T + iTarget, parm_DoT, 3 );

	}

	return PLUGIN_HANDLED;
}


Jp_Fire_Remove( iTarget ) 
{
	// Clear global variables and stop the DoT task

	mass_fjump[iTarget] = false;
	
	new vTargetOrigin[3];
	get_user_origin( iTarget, vTargetOrigin );
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, vTargetOrigin)
	write_byte(TE_SMOKE)
	write_coord(vTargetOrigin[0])			// Position
	write_coord(vTargetOrigin[1])
	write_coord(vTargetOrigin[2] - 50)
	write_short(g_smokeSprr )				// Sprite index
	write_byte(random_num(15, 20))					// scale * 10
	write_byte(random_num(10, 20) )			// framerate
	message_end()

	new TaskId = TASK_FIRE_JIMP_T + iTarget;
    remove_task( TaskId, 0 );

    return PLUGIN_HANDLED;
}