/*
*	Race: Frost Mage Functions
*/

// ****************************************
// Frost Mage Blizzard Ultimate
//   " " - Ultimate
// ****************************************
public FRR_ULT_Blizzard( iAttacker, iVictim )
{
	if(!is_user_connected(iAttacker))
       return PLUGIN_HANDLED;
	
	emit_sound(iAttacker, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL_MISSILE], 1.0, ATTN_NORM, 0, PITCH_NORM );

	//  
	new Float:fOrigin[3];
	entity_get_vector( iAttacker, EV_VEC_origin, fOrigin );

	new skulls = WC3_ENTITY_create( "FRS_COIL", "models/bskull_template1.mdl", fOrigin, MOVETYPE_NOCLIP, SOLID_TRIGGER, FRS_DURATION );
	//new skulls = WC3_ENTITY_create( "FRS_COIL", "models/bskull_template1.mdl", fOrigin, MOVETYPE_BOUNCE, SOLID_BBOX, FRS_DURATION );

	entity_set_edict( skulls, EV_ENT_owner, iAttacker );
	entity_set_edict( skulls, EV_ENT_enemy, iVictim );

	// skulls effects
	set_entity_rendering( skulls, kRenderFxGlowShell, FRS_SHELL_RGB[GLOWS_R], FRS_SHELL_RGB[GLOWS_G], FRS_SHELL_RGB[GLOWS_B], kRenderNormal, 255 );
	Create_TE_BEAMFOLLOW(skulls, g_iSprites[SPR_TRAIL], 10, 20, FRS_TRAIL_RGB[GLOWS_R], FRS_TRAIL_RGB[GLOWS_G], FRS_TRAIL_RGB[GLOWS_B], 255 );

	// Seek iVictim
	new arg_write[1];
	arg_write[0] = skulls;

	fDeathCoilSeeks( arg_write );

	return PLUGIN_HANDLED;
}

public fDeathCoilSeeks( arg_read[1] )
{

	new skulls = arg_read[0];

	if ( !WC3_is_valid_ent( skulls ) )
		return PLUGIN_HANDLED;

	new iVictim = entity_get_edict( skulls, EV_ENT_enemy );

	if ( !is_user_alive( iVictim ) )
		return PLUGIN_HANDLED;

	// Project skulls towards iVictim
	set_velocity_to_ent( skulls, iVictim, FRS_VELOCITY );

	// Repeat until iVictim is hit
	new task = TASK_TEMPENTITY + skulls;
	set_task( 0.1, "fDeathCoilSeeks", task, arg_read, 1 );

	return PLUGIN_HANDLED;
}


static fDeathCoilDamages( iAttacker, iVictim) 
{

	// Play sound
	emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL], 1.0, ATTN_NORM, 0, PITCH_NORM );

	// Generate effects
	fDeathCoilEffectss( iVictim );

	// Unset velocity
	new Float:fVelocity[3];
	entity_get_vector( iVictim, EV_VEC_velocity, fVelocity );

	fVelocity[0] = 0.0;
	fVelocity[1] = 0.0;
	
	WC3_Damage(iVictim, iAttacker, FRS_DAMAGE, CSW_DEATHCOIL, -1 );

	return PLUGIN_HANDLED;
}

static fDeathCoilEffectss( iVictim )
{
	Create_ScreenFade( iVictim, (1<<10), (1<<10), FADE_OUT, FRS_TRAIL_RGB[GLOWS_R], FRS_TRAIL_RGB[GLOWS_G], FRS_TRAIL_RGB[GLOWS_B], 160 );

	new Origin[3];
	get_user_origin( iVictim, Origin );

	Create_TE_SPRITE( Origin, g_iSprites[SPR_FIREMENTS], 5, 200 );

	Create_TE_ELIGHT(iVictim, Origin, 100, FRS_TRAIL_RGB[GLOWS_R], FRS_TRAIL_RGB[GLOWS_G],FRS_TRAIL_RGB[GLOWS_B], 10, 0 );

	return PLUGIN_HANDLED;
}


static fDeathCoilRemoves( skulls ) 
{
	new task = TASK_TEMPENTITY + skulls;
	remove_task( task, 0 );

	if (is_valid_ent(skulls)) 
		remove_entity( skulls );

	return PLUGIN_HANDLED;
}


public touchDeathCoils( entSkull, idWorldPlayer ) 
{	
	if ( idWorldPlayer < 1 || idWorldPlayer > 32 || entSkull < 1 || !is_user_alive( idWorldPlayer ) )
	{
	//	fCreateExplodeIceArrow(entSkull);
	//	fDeathCoilRemove_dk( entSkull );
	//	return PLUGIN_CONTINUE;
	}
	
	if(idWorldPlayer == 0) 
	{
		fCreateExplodeIceArrow(entSkull);
		fDeathCoilRemoves( entSkull );
		
		return PLUGIN_CONTINUE;
	}
	
	//   
	else if(is_user_connected(idWorldPlayer))
	{
		new iAttacker = entity_get_edict( entSkull, EV_ENT_owner );
		new iVictim = entity_get_edict( entSkull, EV_ENT_enemy );
		//         
		if(get_user_team(idWorldPlayer) != get_user_team(iAttacker))
		{
			fDeathCoilDamages( iAttacker, iVictim );
			
			new vOrigin[3], vInitOrigin[3], vAxisOrigin[3], i;
			
			// Get origin of victim
			get_user_origin( iVictim, vOrigin );
			
			emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_FROST1], 1.0, ATTN_NORM, 0, PITCH_NORM );
			
			// Set up the origins for the effect
			vInitOrigin[0] = vOrigin[0];
			vInitOrigin[1] = vOrigin[1];
			vInitOrigin[2] = vOrigin[2] - 16;
			
			vAxisOrigin[2] = vOrigin[2] + FROST_MOGRADIUS2;
			
			Create_TE_BEAMCYLINDER( vOrigin, vInitOrigin, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 10, 30, 0, 0, 100, 255, 255, 0 );

			//---
			new team = get_user_team( iAttacker );
			new players[32], numberofplayers, targetr, vTargetOrigin[3];
			get_players(players, numberofplayers, "a");
			
			// Loop through all players and see if anyone nearby needs to be damaged
			//    .
			for( i = 0; i < numberofplayers; i++ )
			{
			
			targetr = players[i];
			
				if ( is_user_alive( players[i] ) )
				{
					// Then we have a target on the other team!!
					if ( get_user_team( targetr ) != team )
					{
						get_user_origin( targetr, vTargetOrigin );

						// Make sure they are close enough
						if ( get_distance( vOrigin, vTargetOrigin ) <= FROST_MOGRADIUS2 )
						{
						if(p_data_b[targetr][PB_ISFROZENPLAYER] == false)
						{
							//  
							message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, targetr);
							write_short(0);// duration
							write_short(0);// hold time
							write_short(FFADE_STAYOUT);// fade type
							write_byte(0);// red
							write_byte(50);// green
							write_byte(200);// blue
							write_byte(100);// alpha
							message_end();

							fm_set_rendering(targetr, kRenderFxGlowShell, 0, 100, 200, kRenderNormal, 25);

							// Prevent from jumping
							if (pev(targetr, pev_flags) & FL_ONGROUND)
							set_pev(targetr, pev_gravity, 999999.9);// set really high
							else
							set_pev(targetr, pev_gravity, 0.000001);// no gravity

							set_pev(targetr, pev_velocity, Float:{0.0,0.0,0.0});// stop motion
							set_pev(targetr, pev_maxspeed, 1.0);// prevent from moving
							
							WC3_Damage( targetr, iAttacker, DMG_FROST_F2, CSW_CONCOCTION, 0 );
							
							emit_sound( targetr, CHAN_STATIC, g_szSounds[SOUND_FROST2], 1.0, ATTN_NORM, 0, PITCH_NORM );

							p_data_b[targetr][PB_ISFROZENPLAYER] = true;
							
							set_task(FROSTT_TIME2, "removka2", TASK_REMOVE_FROZEN + targetr );
						}
						}
					}
				}
			}
			
			fDeathCoilRemoves( entSkull );
		}
		//        
		else 
		{
			//fCreateExplodeIceArrow(entIceArrow)
			//fDeathCoilRemoves( entSkull );
			//fCreateExplodeIceArrow(entSkull);
		}
	} 
	//       
	else
	{
		fCreateExplodeIceArrow(entSkull);
		fDeathCoilRemoves( entSkull );
		
	}

	return PLUGIN_CONTINUE;
}

public removka2( idUser )
{
	if ( idUser >= TASK_REMOVE_FROZEN )
		idUser -= TASK_REMOVE_FROZEN;

	if ( !p_data_b[idUser][PB_ISCONNECTED] )
		return;

	p_data_b[idUser][PB_ISFROZENPLAYER] = false;

//	client_print(0,print_chat,"fRemoveFreeze");

	SHARED_SetGravity( idUser );
	
	SHARED_SetSpeed( idUser );

	fm_set_rendering(idUser);

	// Gradually remove screen's blue tint
	message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, idUser);
	write_short(UNIT_SECOND);// duration
	write_short(0);// hold time
	write_short(FFADE_IN);// fade type
	write_byte(0);// red
	write_byte(50);// green
	write_byte(200);// blue
	write_byte(100);// alpha
	message_end();
	
	static origin2[3];
	get_user_origin(idUser, origin2);
	
	// Glass shatter
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin2);
	write_byte(TE_BREAKMODEL);
	write_coord(origin2[0]); // x
	write_coord(origin2[1]); // y
	write_coord(origin2[2]+24); // z
	write_coord(16);// size x
	write_coord(16);// size y
	write_coord(16);// size z
	write_coord(random_num(-50, 50));// velocity x
	write_coord(random_num(-50, 50));// velocity y
	write_coord(25);// velocity z
	write_byte(10);// random velocity
	write_short(mdlGlassSpr);// model
	write_byte(10);// count
	write_byte(25);// life
	write_byte(BREAK_GLASS); // flags
	message_end();
	
	emit_sound( idUser, CHAN_STATIC, g_szSounds[SOUND_FROST3], 1.0, ATTN_NORM, 0, PITCH_NORM );

	return;
}

public fDeathCoilSeeksb( arg_read[1] )
{

	new skulls = arg_read[0];

	if ( !WC3_is_valid_ent( skulls ) )
		return PLUGIN_HANDLED;

	new iVictim = entity_get_edict( skulls, EV_ENT_enemy );

	if ( !is_user_alive( iVictim ) )
		return PLUGIN_HANDLED;

	// Project skulls towards iVictim
	set_velocity_to_ent( skulls, iVictim, FRS_VELOCITY );

	// Repeat until iVictim is hit
	new task = TASK_TEMPENTITY + skulls;
	set_task( 0.1, "fDeathCoilSeeksb", task, arg_read, 1 );

	return PLUGIN_HANDLED;
}


static fDeathCoilDamagesb( iAttacker, iVictim ) 
{
	// Play sound
	emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL], 1.0, ATTN_NORM, 0, PITCH_NORM );

	// Generate effects
	fDeathCoilEffectssb( iVictim );

	// Unset velocity
	new Float:fVelocity[3];
	new CsArmorType:ArmorType;
	
	entity_get_vector( iVictim, EV_VEC_velocity, fVelocity );

	fVelocity[0] = 0.0;
	fVelocity[1] = 0.0;
	
	if (get_user_health(iAttacker) < get_user_maxhealth(iAttacker))
	{
	new hpg = random_num(hp_froster_r1, hp_froster_r2);
	
	WC3_Damage(iVictim, iAttacker, hpg, CSW_DEATHCOIL, -1 );
	set_user_health(iAttacker, get_user_health(iAttacker) + hpg);
	if (get_user_health(iAttacker) > get_user_maxhealth(iAttacker))
	{
	set_user_health(iAttacker, get_user_maxhealth(iAttacker));
	}
	}
	
	if (get_user_armor(iAttacker) < 100)
	{
	new apg = random_num(ap_froster_r1, ap_froster_r2);
	
	if (!(get_user_armor(iVictim) <= 0))
	{
	cs_set_user_armor(iVictim, get_user_armor(iVictim) - apg, ArmorType)
	}
	cs_set_user_armor(iAttacker, get_user_armor(iAttacker) + apg, ArmorType)
	if (get_user_armor(iAttacker) > 100)
	{
	cs_set_user_armor(iAttacker, 100, ArmorType)
	}
	}

	return PLUGIN_HANDLED;
}

static fDeathCoilEffectssb( iVictim )
{
	new Origin[3];
	get_user_origin( iVictim, Origin );

	Create_TE_ELIGHT(iVictim, Origin, 100, random_num(0, 255), random_num(0, 255),random_num(0, 255), 10, 0 );

	Create_TE_SPRITE( Origin, g_iSprites[SPR_FIREMENTS], 5, 200 );
	
	Create_ScreenShake( iVictim, (10<<12), (3<<12), (6<<12) );

	return PLUGIN_HANDLED;
}


static fDeathCoilRemovesb( skulls ) 
{
	new task = TASK_TEMPENTITY + skulls;
	remove_task( task, 0 );

	if (is_valid_ent(skulls)) 
		remove_entity( skulls );

	return PLUGIN_HANDLED;
}


public touchDeathCoilsb( entSkull, idWorldPlayer ) 
{	
	if ( idWorldPlayer < 1 || idWorldPlayer > 32 || entSkull < 1 || !is_user_alive( idWorldPlayer ) )
	{
	//	fCreateExplodeIceArrow(entSkull);
	//	fDeathCoilRemove_dk( entSkull );
	//	return PLUGIN_CONTINUE;
	}
	
	//   
	new iAttacker = entity_get_edict( entSkull, EV_ENT_owner );
	new iVictim = entity_get_edict( entSkull, EV_ENT_enemy );
	
	if(idWorldPlayer == 0) 
	{
		fCreateExplodeIceArrow(entSkull);
		fDeathCoilRemovesb( entSkull );
		
		return PLUGIN_CONTINUE;
	}
	
	else if(is_user_connected(idWorldPlayer) || is_user_alive(idWorldPlayer) || is_user_connected(iAttacker) || is_user_alive(iAttacker))
	{
		//         
		if(get_user_team(idWorldPlayer) != get_user_team(iAttacker))
		{
			fDeathCoilDamagesb( iAttacker, iVictim );
			fDeathCoilRemovesb( entSkull );
		}
	} 
	//       
	else
	{
		//fCreateExplodeIceArrow(entIceArrow);
		fCreateExplodeIceArrow(entSkull);
		fDeathCoilRemovesb( entSkull );
		
	}

	return PLUGIN_CONTINUE;
}

// 1  -   (Ice splinters)
FRR_SkillsOffensive( iAttacker, iVictim, iHitPlace )
{
	if ( !p_data_b[iVictim][PB_ISCONNECTED] || !p_data_b[iAttacker][PB_ISCONNECTED] )
		return;

	static iSkillLevel;
		
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_FROST_SPLINTERS );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false && ((get_user_team( iAttacker ) != get_user_team( iVictim ))))
	{
		if ( random_float(0.0, 1.0) <= p_frost_splinters[iSkillLevel-1] )
		{
			new vOrigin[3], pos[3], end[3]; 

            get_user_origin( iVictim, vOrigin); 

            pos[ 0 ] = vOrigin[ 0 ]; 
            pos[ 1 ] = vOrigin[ 1 ]; 
            pos[ 2 ] = vOrigin[ 2 ] - 600; 

            end[0] = vOrigin[0]; 
            end[1] = vOrigin[1];
            end[2] = vOrigin[2] + 600;
						
			//Create_TE_SPRITETRAIL( vAttackerorigin, vVictimOrigin, g_iSprites[SPR_ICE_SPLINTERS], iSkillLevel, 15, 1, 2, 6 );
			Create_TE_SPRITETRAIL(pos, end, g_iSprites[SPR_FROST_F],50, random_num(27,30), 6, random_num(30,70), 40 )
			
			emit_sound( iAttacker, CHAN_STATIC, g_szSounds[SOUND_ICE_SPLINTERS], 1.0, ATTN_NORM, 0, PITCH_NORM );
			emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_ICE_SPLINTERS], 1.0, ATTN_NORM, 0, PITCH_NORM );


			WC3_Damage( iVictim, iAttacker, DMG_FROST_F, CSW_ICE_SPLINTERS, iHitPlace );
		}
		else if ( get_pcvar_num( CVAR_wc3_psychostats ) )
		{
			new WEAPON = CSW_ICE_SPLINTERS - CSW_WAR3_MIN;

			iStatsShots[iAttacker][WEAPON]++;
		}
	}
	
	//
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_FROST_STRIKE );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		if ( random_float(0.0, 1.0 ) <= p_frshadow[iSkillLevel-1] )		
		{
			Create_ScreenFade( iVictim, (1<<10), (2<<10), (1<<12), 0, 255, 255, 255 );
		}
	}
}

public cfgj( iAttacker, iVictim )
{
bbfrostbb( iAttacker, iVictim )
}

static bbfrostbb( iAttacker, iVictim )
{
	if (!is_user_alive(iVictim) || !is_user_alive(iAttacker))
	{
	return PLUGIN_HANDLED;
	}
	
	if (is_user_alive(iVictim) || is_user_alive(iAttacker))
	{
	emit_sound(iAttacker, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL_MISSILE], 1.0, ATTN_NORM, 0, PITCH_NORM );

	//  
	new Float:fOrigin[3];
	entity_get_vector( iAttacker, EV_VEC_origin, fOrigin );

	new skulls = WC3_ENTITY_create( "FRS_COILB", "models/bskull_template1.mdl", fOrigin, MOVETYPE_NOCLIP, SOLID_TRIGGER, FRS_DURATION );
	//new skulls = WC3_ENTITY_create( "FRS_COILB", "models/bskull_template1.mdl", fOrigin, MOVETYPE_BOUNCE, SOLID_BBOX, FRS_DURATION );
	
	entity_set_edict( skulls, EV_ENT_owner, iAttacker);
	entity_set_edict( skulls, EV_ENT_enemy, iVictim);

	// skulls effects
	set_entity_rendering( skulls, kRenderFxGlowShell, random_num(0, 255), random_num(0, 255), random_num(0, 255), kRenderNormal, 48 );
	Create_TE_BEAMFOLLOW(skulls, g_iSprites[SPR_TRAIL], 10, 8, random_num(0, 255), random_num(0, 255), random_num(0, 255), 255 );

	// Seek iVictim
	new arg_write[1];
	arg_write[0] = skulls;

	fDeathCoilSeeksb( arg_write );
	
	return PLUGIN_HANDLED;
	}
	return PLUGIN_HANDLED;
}

FRR_SkillsDefensive( iAttacker, iVictim )
{
	
	static iSkillLevel;

	// Unstable Concoction
	iSkillLevel = SM_GetSkillLevel( iVictim, FROST_COLCO );
	if ( iSkillLevel > 0 && p_data_b[iVictim][PB_ISFROZENSKILL] == false )
	{
		if ( task_exists( TASK_REMOVE_FROZEN + iVictim ) == 0 )
		{
		if ( random_float( 0.0, 1.0 ) <= p_frost_colco[p_data[iAttacker][P_LEVEL]] )
		{
			
			new vOrigin[3], vInitOrigin[3], vAxisOrigin[3], i;
			
			// Get origin of victim
			get_user_origin( iVictim, vOrigin );
			
			emit_sound( iAttacker, CHAN_STATIC, g_szSounds[SOUND_FROST1], 1.0, ATTN_NORM, 0, PITCH_NORM );
			
			// Set up the origins for the effect
			vInitOrigin[0] = vOrigin[0];
			vInitOrigin[1] = vOrigin[1];
			vInitOrigin[2] = vOrigin[2] - 16;
			
			vAxisOrigin[2] = vOrigin[2] + FROST_MOGRADIUS;
			
			Create_TE_BEAMCYLINDER( vOrigin, vInitOrigin, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 10, 30, 0, 0, 100, 255, 255, 0 );

			//---
			new team = get_user_team( iVictim );
			new players[32], numberofplayers, targett, vTargetOrigin[3];
			get_players(players, numberofplayers, "a");
			
			// Loop through all players and see if anyone nearby needs to be damaged
			//    .
			for( i = 0; i < numberofplayers; i++ )
			{
			
			targett = players[i];
			
				if ( is_user_alive( players[i] ) )
				{
					// Then we have a target on the other team!!
					if ( get_user_team( targett ) != team )
					{
						get_user_origin( targett, vTargetOrigin );

						// Make sure they are close enough
						if ( get_distance( vOrigin, vTargetOrigin ) <= FROST_MOGRADIUS )
						{
						if(p_data_b[targett][PB_ISFROZENPLAYER] == false)
						{
							//  
							message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, targett);
							write_short(0);// duration
							write_short(0);// hold time
							write_short(FFADE_STAYOUT);// fade type
							write_byte(0);// red
							write_byte(50);// green
							write_byte(200);// blue
							write_byte(100);// alpha
							message_end();

							fm_set_rendering(targett, kRenderFxGlowShell, 0, 100, 200, kRenderNormal, 25);

							// Prevent from jumping
							if (pev(targett, pev_flags) & FL_ONGROUND)
							set_pev(targett, pev_gravity, 999999.9);// set really high
							else
							set_pev(targett, pev_gravity, 0.000001);// no gravity

							set_pev(targett, pev_velocity, Float:{0.0,0.0,0.0});// stop motion
							set_pev(targett, pev_maxspeed, 1.0);// prevent from moving
							
							WC3_Damage( targett, iVictim, DMG_FROST_F3, CSW_CONCOCTION, 0 );
							
							emit_sound( targett, CHAN_STATIC, g_szSounds[SOUND_FROST2], 1.0, ATTN_NORM, 0, PITCH_NORM );

							p_data_b[targett][PB_ISFROZENPLAYER] = true;
							
							set_task(FROSTT_TIME, "removka", TASK_REMOVE_FROZEN + targett );
						}
						}
					}
				}
			}
		}
	}
}
}

public removka( idUser )
{
	if ( idUser >= TASK_REMOVE_FROZEN )
		idUser -= TASK_REMOVE_FROZEN;

	if ( !p_data_b[idUser][PB_ISCONNECTED] )
		return;

	p_data_b[idUser][PB_ISFROZENPLAYER] = false;

//	client_print(0,print_chat,"fRemoveFreeze");

	SHARED_SetGravity( idUser );
	
	SHARED_SetSpeed( idUser );

	fm_set_rendering(idUser);

	// Gradually remove screen's blue tint
	message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, idUser);
	write_short(UNIT_SECOND);// duration
	write_short(0);// hold time
	write_short(FFADE_IN);// fade type
	write_byte(0);// red
	write_byte(50);// green
	write_byte(200);// blue
	write_byte(100);// alpha
	message_end();
	
	static origin2[3];
	get_user_origin(idUser, origin2);
	
	// Glass shatter
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin2);
	write_byte(TE_BREAKMODEL);
	write_coord(origin2[0]); // x
	write_coord(origin2[1]); // y
	write_coord(origin2[2]+24); // z
	write_coord(16);// size x
	write_coord(16);// size y
	write_coord(16);// size z
	write_coord(random_num(-50, 50));// velocity x
	write_coord(random_num(-50, 50));// velocity y
	write_coord(25);// velocity z
	write_byte(10);// random velocity
	write_short(mdlGlassSpr);// model
	write_byte(10);// count
	write_byte(25);// life
	write_byte(BREAK_GLASS); // flags
	message_end();
	
	emit_sound( idUser, CHAN_STATIC, g_szSounds[SOUND_FROST3], 1.0, ATTN_NORM, 0, PITCH_NORM );

	return;
}