
//#define DEATH_HEALTH 50
public SN_ArmorProduce( id )
{
	if ( task_exists( id + TASK_WAVEARMOR ) == 0 )
	{
		_SN_ArmorProduce( id );
	}
}

public _SN_ArmorProduce( id )
{
	
	if ( id >= TASK_WAVEARMOR )
	{
		id -= TASK_WAVEARMOR;
	}

	// User is no longer connected :/
	if ( !p_data_b[id][PB_ISCONNECTED] )
	{
		return;
	}
	
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( id, SKILL_REGENERATION );

	if ( iSkillLevel > 0 && p_data_b[id][PB_ISFROZENSKILL] == false )
	{

	// Continue healing...
	if ( is_user_alive( id ) )
	{
		set_task( p_regen[iSkillLevel-1], "_SN_ArmorProduce", TASK_WAVEARMOR + id );
	}
	
	// Prevent healing if this player is hexed
	if ( p_data_b[id][PB_HEXED] )
	{
		return;
	}
	
	new players[32], numberofplayers, targetid, targetorigin[3], origin[3];
	new iTeam = get_user_team( id );

	get_user_origin( id, origin );
	get_players( players, numberofplayers, "a" );
	
	// Loop through each player and check to see if one is close enough to be healed
	for ( new i = 0; i < numberofplayers; i++ )
	{
		targetid = players[i];
		
		// User is on the iAttacker's team
		if ( p_data_b[targetid][PB_ISCONNECTED] && get_user_team( targetid ) == iTeam )
		{
			if ( is_user_alive( targetid ) )
			{
				get_user_origin( targetid, targetorigin );
			
				// User is close enough
				if ( get_distance(origin, targetorigin) < aura_range_Shaman )
				{
					get_user_origin( targetid, origin )
			
					// User needs health
					if ( get_user_health( targetid ) < get_user_maxhealth( targetid ) )
					{
						if(sm4_IsPlayerSkeleton(targetid) == false)//Если игрок скелет,лечиться не может
						{
							set_user_health( targetid, get_user_health( targetid ) + hp_give_Shaman );
							
							Create_TE_IMPLOSION( origin, 100, 8, 1 );
						}
					}
					
					// User needs health
					if ( get_user_armor( targetid ) < SHARED_GetMaxArmor( targetid ) )
					{
						if(sm4_IsPlayerSkeleton(targetid) == false)//Если игрок скелет,лечиться не может
						{
							new CsArmorType:ArmorType;
							cs_set_user_armor( targetid, get_user_armor( targetid ) + armor_give_Shaman, ArmorType );
							
							Create_TE_IMPLOSION( origin, 100, 8, 1 );
						}
					}
				}
			}
		}
	}
	}

	return;
}

SN_SkillsOffensive( iAttacker, iVictim, iHitPlace )
{
    if(!is_user_alive( iAttacker ) || !is_user_alive(iVictim))
	return;

	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_CLAWS );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
	   if ( random_float( 0.0, 1.0 ) <= p_claws[iSkillLevel-1] )
	 {
        new vOrigin[3], pos[3], end[3]; 
        get_user_origin( iVictim, vOrigin); 
        pos[ 0 ] = vOrigin[ 0 ]; 
        pos[ 1 ] = vOrigin[ 1 ]; 
        pos[ 2 ] = vOrigin[ 2 ] - 600; 
        end[0] = vOrigin[0] 
        end[1] = vOrigin[1] 
        end[2] = vOrigin[2] + 600
		emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_IMPALE], 1.0, ATTN_NORM, 0, PITCH_NORM );
        new Float:vVelocity[3];
		entity_get_vector( iVictim, EV_VEC_velocity, vVelocity );
        vVelocity[0] = random_float( 100.0, 400.0 );
		vVelocity[1] = random_float( 100.0, 400.0 );
		vVelocity[2] = random_float( 400.0, 700.0 );
	    WC3_Damage( iVictim, iAttacker, claw_dmg_Shaman, CSW_CLAWS, iHitPlace)
        entity_set_vector( iVictim, EV_VEC_velocity, vVelocity );
        new Float:fOrigin[3];
        entity_get_vector( iVictim, EV_VEC_origin, fOrigin );
        fOrigin[2] += 180.0;
        new claw = cssbWar3EntityCreate( "IMPALE_CLAW", "models/tentacle2.mdl", fOrigin, MOVETYPE_TOSS, SOLID_NOT, 1.5 );
		
		if(!cssbWar3EntityValid(claw))
		{
		return;
		}
		
        new Float:fVelocity[3] = { 0.0, 0.0, 500.0 };
        entity_set_vector( claw, EV_VEC_velocity, fVelocity );
        entity_set_float( claw, EV_FL_gravity, 1.5 );
     }
    }

    static iSkillLevelBullet;
    iSkillLevelBullet = SM_GetSkillLevel(iAttacker, SKILL_FIRE_AMMO);
    if(iSkillLevelBullet > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false)
    {
	if(random_float(0.0,1.0) <= p_fire_bullet[iSkillLevelBullet-1])
	{
	ShamanFireBulletEffect(iAttacker,iVictim);
	}
    }	
}


public ShamanFireBulletEffect(iAttacker,iVictim)
{
	new k_origin[3]; 
	new v_origin[3];
	new VictimOrigin[3];
	get_user_origin(iAttacker,k_origin, 1)
	get_user_origin(iVictim,v_origin, 4)
	get_user_origin(iVictim, VictimOrigin, 0);
	Create_TE_EXPLOSION( VictimOrigin, VictimOrigin, g_iSprites[SPR_SN_FIRE], 20, 24, 4 );
	Create_TE_EXPLOSION( VictimOrigin, VictimOrigin, g_iSprites[SPR_SN_BURN], 30, 24, 4 );
	message_begin(MSG_ONE, SVC_TEMPENTITY,{0,0,0}, iVictim)
	write_byte(0)
	write_coord(k_origin[0])
	write_coord(k_origin[1])
	write_coord(k_origin[2]) 	//origins ->
	write_coord(v_origin[0]) 
	write_coord(v_origin[1])
	write_coord(v_origin[2]) 	//origins <-
	write_short( m_spriteTexture )
	write_byte(1)	 		// framestart 
	write_byte(1)		 	// framerate 
	write_byte(3) 			// life in 0.1's 
	write_byte(10) 			// width 
	write_byte(5)  			// noise 
	write_byte(255)   		// r, g, b 
	write_byte(089)   		// r, g, b 
	write_byte(0)   		// r, g, b 
	write_byte(255)   		// brightness 
	write_byte(0)    		// speed
	message_end() 
	
	new team = get_user_team( iAttacker );
	new arrPlayers[32], iNumPlayers, vClosestTargetOrigin[3];
	get_players(arrPlayers, iNumPlayers, "a");

	//Повреждения окружающих огнем
	for(new i = 0; i < iNumPlayers; i++ )
	{
		if ( is_user_alive( arrPlayers[i] ) )
		{
			if (arrPlayers[i] != iAttacker)
			{
				if ( get_user_team( arrPlayers[i] ) == team )
				{
					get_user_origin( arrPlayers[i], vClosestTargetOrigin );

					if ( get_distance( VictimOrigin, vClosestTargetOrigin ) <= dmg_fire_r_Shaman)
					{
						WC3_Damage( arrPlayers[i],iAttacker, dmg_fire_e_Shaman, CSW_IRNER_FIRE, 0 );
											
					}
				}
			}
		}
	}
} 

public SN_SLEEP( iCaster, iTarget ) 
{
    if(!is_user_alive( iCaster ) || !is_user_alive(iTarget))
	return PLUGIN_HANDLED;

    // Удаление Сна
	SN_SLEEP_Remove( iTarget );
	
	g_bShamanIsSleeping[iTarget] = true;

	// Воспроизведение Звука
	emit_sound( iTarget, CHAN_STATIC, g_szSounds[SOUND_SLEEP], 1.0, ATTN_NORM, 0, PITCH_NORM );

	// Смена на нож
	new weapon, iClip, iAmmo;
	weapon = get_user_weapon( iTarget, iClip, iAmmo );

	// Проверка
	if ( weapon != CSW_KNIFE )
	{
    engclient_cmd( iTarget, "weapon_knife" );
	}
	  
	// Подсветка отключена
	p_data_b[iTarget][PB_CAN_RENDER] = false;
	
	// Подсчитывание секунд
	new Float:fDuration = random_float( sleep_d_min_Shaman, sleep_d_max_Shaman );
	new iHoldTime = floatround( fDuration );

	fDuration = float( iHoldTime );
	
	if(!SHARED_IsPlayerSlowed(iTarget))
	{
    p_data_b[iTarget][PB_STUNNED] = true;
	SHARED_SetSpeed( iTarget );		
	set_task( fDuration, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + iTarget );
	}

	set_user_hitzones( iTarget, 0, 0 );
	entity_set_float( iTarget, EV_FL_takedamage, 0.0 );

    // Установка подсветки
	set_user_rendering( iTarget, kRenderFxNone, 0, 0, 0, kRenderTransAdd, 128 );

	// Установка черного экрана
	Create_ScreenFade( iTarget, (1<<12), (iHoldTime<<12), FADE_MODULATE_IN, 0, 0, 0, 255 );

    // Установка бар-тайма
	Create_BarTime( iTarget, iHoldTime, 0 );

	new arg_Z1[3], arg_Z2[3];
	arg_Z1[0] = iTarget;
	arg_Z2[0] = iTarget;

	SN_SLEEP_effect( arg_Z1 );

	new task = TASK_SLEEP + iTarget;
	set_task( 0.4, "SN_SLEEP_effect", task, arg_Z2, 3 );

	new arg_write[1];
	arg_write[0] = iTarget;

	set_task( fDuration, "SN_SLEEP_wake", task, arg_write, 1 );

	return PLUGIN_HANDLED;
}


public SN_SLEEP_effect( arg_read[3] ) 
{

	new target = arg_read[0];
	new sleep_z = arg_read[1];
	new iCounter  = arg_read[2];

	if ( !iCounter )
	{
		new Float:fTargetOrigin[3];
		entity_get_vector( target, EV_VEC_origin, fTargetOrigin );

		fTargetOrigin[2] += 36.0;

		sleep_z = cssbWar3EntityCreate( "SLEEP_Z", "sprites/warcraft3/sleep.spr", fTargetOrigin, MOVETYPE_NOCLIP, SOLID_NOT, 1.5 );
		entity_set_float( sleep_z, EV_FL_renderamt, 128.0 );
		entity_set_int( sleep_z, EV_INT_rendermode, kRenderTransAdd );
		entity_set_int( sleep_z, EV_INT_renderfx, kRenderFxClampMinScale );
		entity_set_edict( sleep_z, EV_ENT_owner, target );
		new Float:fVelocity[3];
		fVelocity[0] = random_float( -10.0, 10.0 );
		fVelocity[1] = random_float( -10.0, 10.0 );
		fVelocity[2] = 25.0;

		entity_set_vector( sleep_z, EV_VEC_velocity, fVelocity );
		entity_set_float( sleep_z, EV_FL_scale, random_float( 0.3, 0.4 ) );
	}

	if ( iCounter <= 10 )
	{
		if ( iCounter > 5 && cssbWar3EntityValid( sleep_z ) )
		{
			new Float:fScale = entity_get_float( sleep_z, EV_FL_scale );

			fScale -= 0.02;
			entity_set_float( sleep_z, EV_FL_scale, fScale );
		}

		//set_user_rendering( target, kRenderFxNone, 0, 0, 0, kRenderTransAdd, 128 );

		iCounter++;

		arg_read[1] = sleep_z;
		arg_read[2] = iCounter;

		new task = TASK_TEMPENTITY + sleep_z;
		set_task( 0.1, "SN_SLEEP_effect", task, arg_read, 3 );
	}

	else if ( g_bShamanIsSleeping[target] )
	{
		arg_read[1] = 0;
		arg_read[2] = 0;

		new task = TASK_TEMPENTITY + sleep_z;
		set_task( 0.5, "SN_SLEEP_effect", task, arg_read, 3 );
	}

	return PLUGIN_HANDLED;
}


public SN_SLEEP_wake( arg_read[1] ) 
{

	new target = arg_read[0];

	Create_ScreenFade( target, (1<<12), 0, FADE_MODULATE_OUT, 0, 0, 0, 0 );

	set_user_hitzones( target, 0, 255 );

	new task = TASK_SLEEP + target;
	set_task( sleep_mtype_Shaman, "SN_SLEEP_Finish", task, arg_read, 1 );

	g_bShamanIsSleeping[target] = false;

	SHARED_SetSpeed( target );	

	return PLUGIN_HANDLED;
}


public SN_SLEEP_Finish( arg_read[1] ) 
{

	new target = arg_read[0];
	SN_SLEEP_Remove( target );

	return PLUGIN_HANDLED;
}


public SN_SLEEP_Remove( id ) 
{

	new task = TASK_SLEEP + id;
	remove_task( task, 0 );

	g_bShamanIsSleeping[id] = false;

	set_user_hitzones( id, 0, 255 );
	entity_set_float( id, EV_FL_takedamage, 2.0 );
	
	p_data_b[id][PB_CAN_RENDER] = true;

	set_user_rendering( id );

	SHARED_SetSpeed( id );

	cssbWar3EntityRemoveClass( "SLEEP_Z", id );


	return PLUGIN_HANDLED;
}
