
new g_F_counter[33];

new const szModelC[] = "models/warcraft3/k_p.mdl";

StrajSkillsOffensive( iAttacker, iVictim )
{
static iSkillLevel;

iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_BLACK_RAVEN );
if(iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false)
{
if(random_float( 0.0, 1.0 ) <= p_black_raven[iSkillLevel-1] )
{
fCreateEntity(iVictim);
CER_ULT_Immolate(iAttacker, iVictim);		
}
}
}

SR_Evasion( idUser, iHitZone )
{
	static iSkillLevel;

	// Check to see if they should evade this shot?
	iSkillLevel = SM_GetSkillLevel( idUser, SKILL_SOUL_SCREAM );

	if ( !p_data_b[idUser][PB_HEXED] && iSkillLevel > 0 && random_float( 0.0, 1.0 ) <= p_soul_scream[iSkillLevel-1] && p_data_b[idUser][PB_ISFROZENSKILL] == false)
	{
		new iGlowIntensity = random_num( 20, 50 );
		
		// Head shot
		if ( iHitZone & (1 << HITGROUP_HEAD) )
		{
			iGlowIntensity += 250;
		}

		// Chest
		else if ( iHitZone & (1 << HITGROUP_CHEST) )
		{
			iGlowIntensity += 75;
		}
		
		// Make the user glow!
		SHARED_Glow( idUser, 0, 0, iGlowIntensity, 0 );

		Create_ScreenFade( idUser, (1<<10), (1<<10), (1<<12), 0, 0, 255, g_GlowLevel[idUser][2] );

		return 1;
		
	}

	return 0;
}

public fCreateEntity(idUser)
 {
	if (!is_user_alive(idUser)) 
		return PLUGIN_HANDLED;
		
	new cerb = engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString,"info_target"));
	
	set_pev(cerb, pev_classname, "spdgh");
	
	engfunc(EngFunc_SetSize,cerb,Float:{-1.0,-1.0,-1.0},Float:{1.0,1.0,1.0});
	engfunc(EngFunc_SetModel, cerb, szModelC);

	// put it at their feet
	new Float:novaOrigin[3];
	pev(idUser,pev_origin,novaOrigin);
	novaOrigin[2] -= 30;
	engfunc(EngFunc_SetOrigin,cerb,novaOrigin);
	
	fm_set_rendering(cerb, kRenderFxGlowShell, 200, 200, 0, kRenderNormal, 35)
	set_pev(cerb, pev_movetype, MOVETYPE_TOSS)
	
	p_data_b[idUser][PB_STUNNED] = true;
	SHARED_SetSpeed( idUser );
			
	set_task( ht_vr_CERBERUS, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + idUser );
	set_task(ht_vr_CERBERUS,"task_remove_ent",TASK_REMOVE_ENTSS + idUser);

	return PLUGIN_HANDLED;

}

public task_remove_ent(idUser)
{
	if ( idUser >= TASK_REMOVE_ENTSS )
	{
		idUser -= TASK_REMOVE_ENTSS;
	}
	
	new entc = find_ent_by_class(idUser, "spdgh")

	if(pev_valid(entc))
	{
	remove_entity( entc )
	}
}

public CER_ULT_Immolate( iCaster, iTarget )
{
	// Emit sound and create the fire exploding effect on the player

	if(is_user_alive(iTarget) && is_user_connected(iCaster) && is_user_connected(iTarget))
	{
	new Origin[3];
	
	for ( new i = 0; i < 2; i++ )
	{
		get_user_origin( iTarget, Origin );

		for ( new j = 0; j < 5; j++ )
		{
			Origin[0] += random_num( -15,15 ) * j;
			Origin[1] += random_num( -15,15 ) * j;
			Origin[2] += random_num( -20,25 ) * j;

			Create_TE_BLOODSPRITE(Origin, g_iSprites[SPR_BLOODSPRAY],g_iSprites[SPR_BLOODDROP], 248, 15 );
		}
	}

	WC3_Damage( iTarget, iCaster, hp_vamp_CERBERUS, CSW_SHADOW, -1 );
	
	if(is_user_alive(iCaster))
	{
	if ( get_user_health(iCaster) + hp_vamp_CERBERUS > get_user_maxhealth(iCaster))
	{
	set_user_health(iCaster, get_user_maxhealth(iCaster));
	}
	else
	{
	set_user_health(iCaster, get_user_health(iCaster) + hp_vamp_CERBERUS);
	}
	}

	new parm_DoTs[3];
	parm_DoTs[0] = iCaster;
	parm_DoTs[1] = iTarget;
	parm_DoTs[2] = 1;

	// Start the ultimate DoT

	new TaskId = TASK_DELL_HP + iTarget;
	set_task( 1.0, "CER_ULT_Immolate_DoT", TaskId, parm_DoTs, 3 );
	}
	
	return PLUGIN_HANDLED;
}

public CER_ULT_Immolate_DoT( parm_DoTs[3] )
{
	new iCaster = parm_DoTs[0];
    new iTarget = parm_DoTs[1];
	new iCounter = parm_DoTs[2];
	
	if(is_user_alive(iTarget) && is_user_connected(iCaster) && is_user_connected(iTarget))
	{
	// Stop DoT if the max number of ticks is reached

	if ( iCounter > 4 ) 
	{
		CER_ULT_Immolate_Remove( iTarget );
		return PLUGIN_HANDLED;
	}
	new Origin[3];

	for ( new i = 0; i < 2; i++ )
	{
		get_user_origin( iTarget, Origin );

		for ( new j = 0; j < 5; j++ )
		{
			Origin[0] += random_num( -15,15 ) * j;
			Origin[1] += random_num( -15,15 ) * j;
			Origin[2] += random_num( -20,25 ) * j;

			Create_TE_BLOODSPRITE(Origin, g_iSprites[SPR_BLOODSPRAY],g_iSprites[SPR_BLOODDROP], 248, 15 );
		}
	}

	// Do the DoT damage

	WC3_Damage( iTarget, iCaster, hp_vamp_CERBERUS, CSW_SHADOW, -1 );
	
	if(is_user_alive(iCaster))
	{
	if ( get_user_health(iCaster) + hp_vamp_CERBERUS > get_user_maxhealth(iCaster))
	{
	set_user_health(iCaster, get_user_maxhealth(iCaster));
	}
	else
	{
	set_user_health(iCaster, get_user_health(iCaster) + hp_vamp_CERBERUS);
	}
	}

	// If the target is still alive after this, make their screen glow orange and start the task again

    if ( is_user_alive( iTarget ) )
    {
		parm_DoTs[2]++;

		set_task( 1.0, "CER_ULT_Immolate_DoT", TASK_DELL_HP + iTarget, parm_DoTs, 3 );

	}
	}

	return PLUGIN_HANDLED;
}


CER_ULT_Immolate_Remove( iTarget ) 
{
	new TaskId = TASK_DELL_HP + iTarget;
    remove_task( TaskId, 0 );

    return PLUGIN_HANDLED;
}

public dell_cerber_tt() 
{
	new gsgsg  = find_ent_by_class(-1, "spdgh")
	while(gsgsg) 
	{
		remove_entity(gsgsg)
		gsgsg = find_ent_by_class(-1, "spdgh")
	}
}

public respawn_menu(idUser)
{   
    static iSkillLevel;

    iSkillLevel = SM_GetSkillLevel( idUser, SKILL_SHADOW_CLOAK );
    if ( iSkillLevel > 0 && p_data_b[idUser][PB_ISFROZENSKILL] == false )
    {

	if(random_float( 0.0, 1.0 ) <= p_respawn_die_c[iSkillLevel-1] )
	{
	if(g_F_counter[idUser] < 4)
	{
	if (!is_user_alive(idUser)) 
		return;
	
	new iTeamCurrentUser;
	iTeamCurrentUser = get_user_team(idUser);

	new arrPlayers[32], iNumPlayers;

	if(iTeamCurrentUser == TEAM_T)
		get_players( arrPlayers, iNumPlayers, "be","TERRORIST");
	if(iTeamCurrentUser == TEAM_CT)
		get_players( arrPlayers, iNumPlayers, "be","CT");
		
		
	//Не хватает мертвых игроков для оживления
	if(iNumPlayers < 1)
	{
		WC3_StatusText( idUser, 0, "%L", LANG_PLAYER, "WC3_TEMPID_LIVE" );

		return;
	}

	for (new iCCCount = 0; iCCCount < 1; iCCCount++ )
	{
		new iAliveC = random_num(0,iNumPlayers - 1);

		new cervic = -1;
		for (new i = 0; i < iNumPlayers; i++ )
		{
			cervic = arrPlayers[i];

			if(cervic == idUser)
				continue;

			if(iAliveC == i)
			{
				new ent = SHARED_FindFreeSpawn( cervic, true );
				if ( ent < 0 )
				{
					WC3_StatusText( idUser, 0, "%L", LANG_PLAYER, "NO_FREE_SPAWN_FOUND" );
					return;
				}
				else
				{
					ExecuteHamB(Ham_CS_RoundRespawn,cervic);
					
					new iNewMoney = SHARED_GetUserMoney( idUser ) + 450;
					SHARED_SetUserMoney( idUser, iNewMoney );
					
					 new szMessage[256];
					 format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
					 LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
					 LANG_PLAYER,"WC3_RESPAWN_MONEY_PLUS");
					 cssbColoredPrint(idUser, szMessage);
					 
					new iStoledMoney = SHARED_GetUserMoney( cervic ) - 450;
					SHARED_SetUserMoney( cervic, iStoledMoney ); 

					format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
					LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
					LANG_PLAYER,"WC3_RESPAWN_MONEY_MINUS");
					cssbColoredPrint(cervic, szMessage);					

					new vOrigin[3], vNewOrigin[3], Float:fSpawnOrigin[3];
					
					get_user_origin( cervic, vOrigin );
					entity_get_vector( ent, EV_VEC_origin, fSpawnOrigin );
					FVecIVec( fSpawnOrigin, vNewOrigin );
					set_user_origin( cervic, vNewOrigin );
					Create_TE_TELEPORT( vNewOrigin );
															
					emit_sound( cervic, CHAN_STATIC, g_szSounds[SOUND_RESPAWN], 1.0, ATTN_NORM, 0, PITCH_NORM );
					
				}

				break;
			}
			
		}
	}
	
	}
	else
	{
	return;
	}
	}
	g_F_counter[idUser]++
	}
	
     return; 
}

public SR_ULT_BlueStorm( iCaster, iTarget, iBodyPart )
{
//	client_print(0,print_chat,"FM_ULT_Blizzard");

	emit_sound(iCaster, CHAN_STATIC, g_szSounds[SOUND_BLIZZARD], 0.5, ATTN_NORM, 0, PITCH_NORM );

	new vOrigin[3];
	get_user_origin( iTarget, vOrigin );

	new ptStartBlizzard[3], ptEndBlizzard[3];
	ptStartBlizzard[0] = vOrigin[0];
	ptStartBlizzard[1] = vOrigin[1];
	ptStartBlizzard[2] = vOrigin[2] + 600;
	ptEndBlizzard[0] = vOrigin[0];
	ptEndBlizzard[1] = vOrigin[1];
	ptEndBlizzard[2] = vOrigin[2] - 600;

	WC3_Damage(iTarget, iCaster, CER_DAMAGE_u_CERBERUS, CSW_BLIZZARD, iBodyPart );

	Create_TE_BEAMPOINTS( ptStartBlizzard, ptEndBlizzard, g_iSprites[SPR_NEWFIREMAGE], 5, 9, 9, 500, 25, 255, 0, 0, 255, 10 );

	//Ледяные болты
	for(new i = 1; i < 6; i++) 
		Create_TE_SPRITETRAIL(ptStartBlizzard, ptEndBlizzard, g_iSprites[SPR_FIREMAGEBELLS],100, random_num(50,100), 2, random_num(10,30), 40 )

	new team = get_user_team( iTarget );
	new arrPlayers[32], iNumPlayers, vClosestTargetOrigin[3];
	get_players(arrPlayers, iNumPlayers, "a");

	//Повреждения окружающих рассыпанными ледяными болтами
	for(new i = 0; i < iNumPlayers; i++ )
	{
		if ( is_user_alive( arrPlayers[i] ) )
		{
			if (arrPlayers[i] != iTarget)
			{
				if ( get_user_team( arrPlayers[i] ) == team )
				{
					get_user_origin( arrPlayers[i], vClosestTargetOrigin );

					if ( get_distance( vOrigin, vClosestTargetOrigin ) <= CER_RRR_CERBERUS )
					{
						WC3_Damage( arrPlayers[i],iCaster, CER_DAMAGE_u2_CERBERUS, CSW_BLIZZARD, 0 );
											
						emit_sound(iTarget, CHAN_STATIC, g_szSounds[SOUND_BLIZZARD], 0.5, ATTN_NORM, 0, PITCH_NORM );
					}
				}
			}
		}
	}
	
	return PLUGIN_HANDLED;
}