/*
* Ледяной Шар Скилл №1
*/

new FROST_BALL_DAMAGE = 20; // Урон от ледяного шара
new LIGHTNING_BOLT_DAMAGE = 65; // Урон от ульты
new Float:FREEZ_FROST_BALL = 2.0;
new LIGHTNING_BOLT_DAMAGERR = 30;
new LIGHTNING_BOLT_R = 100;

public fCreateStatusArray(idUser)
{
    if(is_user_alive(idUser))
	{
	static iSkillLevel_WaterMage;
	iSkillLevel_WaterMage = SM_GetSkillLevel( idUser, SKILL_FROST_SHIELD );
	if (iSkillLevel_WaterMage > 0 && arrFrostShieldCharges[idUser] > 0 )
	{
		set_hudmessage(255, 0, 0, 0.43, 0.89, 0, 6.0, 12.0)
		show_hudmessage(idUser, "%L", LANG_PLAYER, "WC3_FROST_CHARGES", arrFrostShieldCharges[idUser])
	}
	}
}

WaterMageSkillsOffensive( iAttacker, iVictim )
{
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_FROST_BALL );
	if( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		if( random_float( 0.0, 1.0 ) <= p_frost_ball[iSkillLevel-1] )
		{
			emit_sound(iAttacker, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL_MISSILE], 1.0, ATTN_NORM, 0, PITCH_NORM );
			fCreateFrostBall(iAttacker);
			
			if(iSkillLevel >= MAX_SKILL_LEVEL / 3)
			{
				set_task( 0.3, "fCreateFrostBall", iAttacker );
			}
			
			if(iSkillLevel >= MAX_SKILL_LEVEL / 1.5)
			{
				set_task( 0.6, "fCreateFrostBall", iAttacker );
			}
			
			if(iSkillLevel == MAX_SKILL_LEVEL)
			{
				set_task( 0.9, "fCreateFrostBall", iAttacker );
			}
		}
	}
 
	static SkillDeepFreezing;
	SkillDeepFreezing = SM_GetSkillLevel( iAttacker, SKILL_DEEP_FREEZING );
	if( SkillDeepFreezing > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		if( random_float( 0.0, 1.0 ) <= p_deep_freezing[SkillDeepFreezing-1] )
		{
			if( !SHARED_IsPlayerSlowed( iVictim ) )
			{
			p_data_b[iVictim][PB_STUNNED] = true;
			SHARED_SetSpeed( iVictim );
			set_task( 2.0, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + iVictim );
			}
		}
	}
}

public fCreateFrostBall(idAttacker)
 {
	if (!is_user_alive(idAttacker)) 
		return PLUGIN_HANDLED;

	new Float: fOrigin[3], Float:fAngle[3],Float: fVelocity[3];
	pev(idAttacker, pev_origin, fOrigin);
	pev(idAttacker, pev_view_ofs, fAngle);
	fm_velocity_by_aim(idAttacker, 2.0, fVelocity, fAngle);
	fAngle[0] *= -1.0;
	
	// create ent
	new entFrostBall = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	set_pev(entFrostBall, pev_classname, "FrostBall");
	engfunc(EngFunc_SetModel, entFrostBall, "sprites/warcraft3/frost_ball.spr");
	set_pev(entFrostBall, pev_mins, Float:{-1.0, -1.0, -1.0});
	set_pev(entFrostBall, pev_maxs, Float:{1.0, 1.0, 1.0});
	set_pev(entFrostBall, pev_origin, fOrigin);
	set_pev(entFrostBall, pev_scale, 0.5 );
	fOrigin[0] += fVelocity[0];
	fOrigin[1] += fVelocity[1];
	fOrigin[2] += fVelocity[2];

	entity_set_float(entFrostBall,EV_FL_framerate,1.0);//framerate
	entity_set_int(entFrostBall, EV_INT_rendermode, 5);//randermode
	entity_set_float(entFrostBall, EV_FL_renderamt, 255.0);//visable

	set_pev(entFrostBall, pev_movetype, MOVETYPE_BOUNCE);
	set_pev(entFrostBall, pev_gravity, 0.01);
	fVelocity[0] *= 1000;
	fVelocity[1] *= 1000;
	fVelocity[2] *= 1000;
	set_pev(entFrostBall, pev_velocity, fVelocity);
	set_pev(entFrostBall, pev_owner, idAttacker);
	set_pev(entFrostBall, pev_angles, fAngle);
	set_pev(entFrostBall, pev_solid, SOLID_BBOX);//store the enitty id
	
	// invisible ent
	//fm_set_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 0);
	
	// show trail	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY );
	write_byte(TE_BEAMFOLLOW);
	write_short(entFrostBall);//entity
	write_short(g_iSprites[SPR_ICE_ARROW_TRAIL]);//model
	write_byte(25);// byte (life in 0.1's)
	write_byte(25);// byte (line width in 0.1's)
	write_byte(255);// byte (color)
	write_byte(255);// byte (color)
	write_byte(255);// byte (color)
	write_byte(255);// byte (brightness)
	message_end();

	return PLUGIN_HANDLED;

}

//Создание взрыва при прикосновении стрелы с игроком или поверхностью
public fCreateFrostBallExplode(entFrostBall)
{
	new Float:fOrigin[3];
	new iOrigin[3];
	entity_get_vector(entFrostBall, EV_VEC_origin, fOrigin);
	FVecIVec(fOrigin, iOrigin);

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_GLOWSPRITE);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]);
	write_short(g_iSprites[SPR_ICE_EXPLODE]);// model
	write_byte(3);// life 0.x sec
	write_byte(6);	// size
	write_byte(110);// brightness
	message_end();

	emit_sound(entFrostBall, CHAN_AUTO, g_szSounds[SOUND_ICE_EXPLODE], 1.0, ATTN_NORM, 0, PITCH_NORM);

	if (is_valid_ent(entFrostBall)) 
		remove_entity(entFrostBall);
}


public touchFrostBall(entFrostBall,idWorldPlayer) 
{
	//Если стрела попадает в какое-нибудь место (стена,пол и т.д.)
	if(idWorldPlayer == 0) 
	{
		fCreateFrostBallExplode(entFrostBall);
	}
	//Если стрела попадает в игрока
	else if(is_user_connected(idWorldPlayer) && p_data_b[idWorldPlayer][PB_ISFROZENPLAYER] == false)
	{
		//Если стрела попадает в игрока и он не из твоей команды
		new idAttacker = entity_get_edict(entFrostBall,EV_ENT_owner);
		if(get_user_team(idWorldPlayer) != get_user_team(idAttacker))
		{
			//Создание эффекта заморозки
			message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, idWorldPlayer);
			write_short(0);// duration
			write_short(0);// hold time
			write_short(FFADE_STAYOUT);// fade type
			write_byte(0);// red
			write_byte(50);// green
			write_byte(200);// blue
			write_byte(100);// alpha
			message_end();

			SHARED_GlowShell( idWorldPlayer, 0, 100, 200, 2.0, 25 );
			
			if(!SHARED_IsPlayerSlowed(idWorldPlayer))
			{
			p_data_b[idWorldPlayer][PB_STUNNED] = true;
			SHARED_SetSpeed( idWorldPlayer );
			WC3_Damage( idWorldPlayer, idAttacker, FROST_BALL_DAMAGE, CSW_FROST_BALL, 0 );
			set_task( FREEZ_FROST_BALL, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + idWorldPlayer );
			set_task( FREEZ_FROST_BALL, "REMOVE_DD", idWorldPlayer);
			}
				
			fCreateFrostBallExplode(entFrostBall);

		}
		//Если стрела попадает в игрока и он из твоей команды
		else 
		{
			fCreateFrostBallExplode(entFrostBall)
		}
	} 
	//Если игрок запустил стрелу и вышел с сервера
	else
	{
		fCreateFrostBallExplode(entFrostBall);
	}
}

public REMOVE_DD(idUser)
{
	if ( !p_data_b[idUser][PB_ISCONNECTED] )
		return;
	
	message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, idUser);
	write_short(UNIT_SECOND);// duration
	write_short(0);// hold time
	write_short(FFADE_IN);// fade type
	write_byte(0);// red
	write_byte(50);// green
	write_byte(200);// blue
	write_byte(100);// alpha
	message_end();	
	
	return;
}	

public fWaterMageGiveCharges(idUser)
{
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( idUser, SKILL_FROST_SHIELD );
	if( iSkillLevel > 0 )
	{
		arrFrostShieldCharges[idUser] = iSkillLevel / 2;
	}
	else
	{
		arrFrostShieldCharges[idUser] = 0;
	}
}

public fCreateUltimateLightningBolt( iCaster, iTarget, iBodyPart )
{
	new vOrigin[3], pos[3], end[3], vAxisOrigin[3], vInitOrigin[3];
	
	get_user_origin( iTarget, vOrigin); 

	pos[ 0 ] = vOrigin[ 0 ]; 
	pos[ 1 ] = vOrigin[ 1 ]; 
	pos[ 2 ] = vOrigin[ 2 ] + 600; 

	end[0] = vOrigin[0] 
	end[1] = vOrigin[1] 
	end[2] = vOrigin[2] - 600
 
	emit_sound( iCaster, CHAN_STATIC, g_szSounds[SOUND_LIGHTNING], 1.0, ATTN_NORM, 0, PITCH_LOW );
	emit_sound(iCaster, CHAN_STATIC, g_szSounds[SOUND_DEATHCOIL_MISSILE], 1.0, ATTN_NORM, 0, PITCH_NORM );
    
	Create_TE_BEAMPOINTS(pos, end, g_iSprites[SPR_BLUE_LIGHTNING],5, 9, 5, 500, 25, 0, 255, 255, 255, 10);

	vInitOrigin[0] = vOrigin[0];
	vInitOrigin[1] = vOrigin[1];
	vInitOrigin[2] = vOrigin[2] - 16;
	
	vAxisOrigin[2] += vOrigin[2] + LIGHTNING_BOLT_R;
	Create_TE_BEAMCYLINDER(vOrigin, vInitOrigin, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 10, 25, 0, 0, 255, 255, 255, 0)
 
	WC3_Damage( iTarget, iCaster, LIGHTNING_BOLT_DAMAGE, CSW_LIGHTNING_BOLT, iBodyPart );
	
	new team = get_user_team( iTarget );
	new arrPlayers[32], iNumPlayers, vClosestTargetOrigin[3];
	get_players(arrPlayers, iNumPlayers, "a");

	//Повреждения окружающих рассыпанными ледяными болтами
	for(new i = 0; i < iNumPlayers; i++ )
	{
		if ( is_user_alive( arrPlayers[i] ) )
		{
			if (arrPlayers[i] != iTarget)
			{
				if ( get_user_team( arrPlayers[i] ) == team )
				{
					get_user_origin( arrPlayers[i], vClosestTargetOrigin );

					if ( get_distance( vOrigin, vClosestTargetOrigin ) <= LIGHTNING_BOLT_R )
					{
						WC3_Damage( arrPlayers[i], iCaster, LIGHTNING_BOLT_DAMAGERR, CSW_SKULL, 0 );
					}
				}
			}
		}
	}
 
	return PLUGIN_HANDLED;
}
